/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){var e=["exports","require","vs/base/common/platform","vs/base/common/strings","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/base/common/functional","vs/base/common/network","vs/base/common/lifecycle","vs/base/common/iterator","vs/base/common/event","vs/base/common/extpath","vs/base/common/arrays","vs/base/common/map","vs/base/common/glob","vs/base/common/cancellation","vs/base/common/process","vs/base/common/async","vs/base/common/linkedList","vs/base/common/resources","vs/base/common/mime","vs/base/common/uuid","vs/workbench/contrib/resources/browser/resourceServiceWorker"],t=function(t){for(var n=[],r=0,i=t.length;r<i;r++)n[r]=e[t[r]];return n},n=this,r="object"==typeof global?global:{};!function(e){e.global=n;var t=function(){function t(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(t.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!0,
configurable:!0}),Object.defineProperty(t.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!0,configurable:!0}),t.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode="undefined"!=typeof module&&!!module.exports,this._isElectronRenderer="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type,this._isWebWorker="function"==typeof e.global.importScripts)},t._isWindows=function(){return!!("undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0)||"undefined"!=typeof process&&"win32"===process.platform},t}();e.Environment=t}(s||(s={}))
;!function(e){var t=function(){return function(e,t,n){this.type=e,this.detail=t,this.timestamp=n}}();e.LoaderEvent=t;var n=function(){function n(e){this._events=[new t(1,"",e)]}return n.prototype.record=function(n,r){this._events.push(new t(n,r,e.Utilities.getHighPerformanceTimestamp()))},n.prototype.getEvents=function(){return this._events},n}();e.LoaderEventRecorder=n;var r=function(){function e(){}return e.prototype.record=function(e,t){},e.prototype.getEvents=function(){return[]},e.INSTANCE=new e,e}();e.NullLoaderEventRecorder=r}(s||(s={}));!function(e){var t=function(){function t(){}return t.fileUriToFilePath=function(e,t){if(t=decodeURI(t).replace(/%23/g,"#"),e){if(/^file:\/\/\//.test(t))return t.substr(8);if(/^file:\/\//.test(t))return t.substr(5)}else if(/^file:\/\//.test(t))return t.substr(7);return t},t.startsWith=function(e,t){return e.length>=t.length&&e.substr(0,t.length)===t},t.endsWith=function(e,t){return e.length>=t.length&&e.substr(e.length-t.length)===t},t.containsQueryString=function(e){
return/^[^\#]*\?/gi.test(e)},t.isAbsolutePath=function(e){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(e)},t.forEachProperty=function(e,t){if(e){var n=void 0;for(n in e)e.hasOwnProperty(n)&&t(n,e[n])}},t.isEmpty=function(e){var n=!0;return t.forEachProperty(e,function(){n=!1}),n},t.recursiveClone=function(e){if(!e||"object"!=typeof e)return e;var n=Array.isArray(e)?[]:{};return t.forEachProperty(e,function(e,r){n[e]=r&&"object"==typeof r?t.recursiveClone(r):r}),n},t.generateAnonymousModule=function(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="},t.isAnonymousModule=function(e){return t.startsWith(e,"===anonymous")},t.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=e.global.performance&&"function"==typeof e.global.performance.now),this.HAS_PERFORMANCE_NOW?e.global.performance.now():Date.now()},t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,t}();e.Utilities=t}(s||(s={}));!function(e){
function t(e){if(e instanceof Error)return e;var t=new Error(e.message||String(e)||"Unknown Error");return e.stack&&(t.stack=e.stack),t}e.ensureError=t;var n=function(){function n(){}return n.validateConfigurationOptions=function(n){function r(e){return"loading"===e.phase?(console.error('Loading "'+e.moduleId+'" failed'),console.error(e),console.error("Here are the modules that depend on it:"),void console.error(e.neededBy)):"factory"===e.phase?(console.error('The factory method of "'+e.moduleId+'" has thrown an exception'),void console.error(e)):void 0}if("string"!=typeof(n=n||{}).baseUrl&&(n.baseUrl=""),"boolean"!=typeof n.isBuild&&(n.isBuild=!1),"object"!=typeof n.paths&&(n.paths={}),"object"!=typeof n.config&&(n.config={}),void 0===n.catchError&&(n.catchError=!1),void 0===n.recordStats&&(n.recordStats=!1),"string"!=typeof n.urlArgs&&(n.urlArgs=""),"function"!=typeof n.onError&&(n.onError=r),Array.isArray(n.ignoreDuplicateModules)||(n.ignoreDuplicateModules=[]),
n.baseUrl.length>0&&(e.Utilities.endsWith(n.baseUrl,"/")||(n.baseUrl+="/")),"string"!=typeof n.cspNonce&&(n.cspNonce=""),Array.isArray(n.nodeModules)||(n.nodeModules=[]),n.nodeCachedData&&"object"==typeof n.nodeCachedData&&("string"!=typeof n.nodeCachedData.seed&&(n.nodeCachedData.seed="seed"),("number"!=typeof n.nodeCachedData.writeDelay||n.nodeCachedData.writeDelay<0)&&(n.nodeCachedData.writeDelay=7e3),!n.nodeCachedData.path||"string"!=typeof n.nodeCachedData.path)){var i=t(new Error("INVALID cached data configuration, 'path' MUST be set"));i.phase="configuration",n.onError(i),n.nodeCachedData=void 0}return n},n.mergeConfigurationOptions=function(t,r){void 0===t&&(t=null),void 0===r&&(r=null);var i=e.Utilities.recursiveClone(r||{});return e.Utilities.forEachProperty(t,function(t,n){"ignoreDuplicateModules"===t&&void 0!==i.ignoreDuplicateModules?i.ignoreDuplicateModules=i.ignoreDuplicateModules.concat(n):"paths"===t&&void 0!==i.paths?e.Utilities.forEachProperty(n,function(e,t){return i.paths[e]=t
}):"config"===t&&void 0!==i.config?e.Utilities.forEachProperty(n,function(e,t){return i.config[e]=t}):i[t]=e.Utilities.recursiveClone(n)}),n.validateConfigurationOptions(i)},n}();e.ConfigurationOptionsUtil=n;var r=function(){function t(e,t){if(this._env=e,this.options=n.mergeConfigurationOptions(t),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),""===this.options.baseUrl){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var r=this.options.nodeRequire.main.filename,i=Math.max(r.lastIndexOf("/"),r.lastIndexOf("\\"));this.options.baseUrl=r.substring(0,i+1)}if(this.options.nodeMain&&this._env.isNode){var r=this.options.nodeMain,i=Math.max(r.lastIndexOf("/"),r.lastIndexOf("\\"));this.options.baseUrl=r.substring(0,i+1)}}}return t.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={}
;for(var e=0;e<this.options.ignoreDuplicateModules.length;e++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[e]]=!0},t.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var e=0,t=this.options.nodeModules;e<t.length;e++){var n=t[e];this.nodeModulesMap[n]=!0}},t.prototype._createSortedPathsRules=function(){var t=this;this.sortedPathsRules=[],e.Utilities.forEachProperty(this.options.paths,function(e,n){Array.isArray(n)?t.sortedPathsRules.push({from:e,to:n}):t.sortedPathsRules.push({from:e,to:[n]})}),this.sortedPathsRules.sort(function(e,t){return t.from.length-e.from.length})},t.prototype.cloneAndMerge=function(e){return new t(this._env,n.mergeConfigurationOptions(e,this.options))},t.prototype.getOptionsLiteral=function(){return this.options},t.prototype._applyPaths=function(t){for(var n,r=0,i=this.sortedPathsRules.length;r<i;r++)if(n=this.sortedPathsRules[r],e.Utilities.startsWith(t,n.from)){
for(var s=[],o=0,a=n.to.length;o<a;o++)s.push(n.to[o]+t.substr(n.from.length));return s}return[t]},t.prototype._addUrlArgsToUrl=function(t){return e.Utilities.containsQueryString(t)?t+"&"+this.options.urlArgs:t+"?"+this.options.urlArgs},t.prototype._addUrlArgsIfNecessaryToUrl=function(e){return this.options.urlArgs?this._addUrlArgsToUrl(e):e},t.prototype._addUrlArgsIfNecessaryToUrls=function(e){if(this.options.urlArgs)for(var t=0,n=e.length;t<n;t++)e[t]=this._addUrlArgsToUrl(e[t]);return e},t.prototype.moduleIdToPaths=function(t){if(!0===this.nodeModulesMap[t])return this.isBuild()?["empty:"]:["node|"+t];var n,r=t;if(e.Utilities.endsWith(r,".js")||e.Utilities.isAbsolutePath(r))e.Utilities.endsWith(r,".js")||e.Utilities.containsQueryString(r)||(r+=".js"),n=[r];else for(var i=0,s=(n=this._applyPaths(r)).length;i<s;i++)this.isBuild()&&"empty:"===n[i]||(e.Utilities.isAbsolutePath(n[i])||(n[i]=this.options.baseUrl+n[i]),e.Utilities.endsWith(n[i],".js")||e.Utilities.containsQueryString(n[i])||(n[i]=n[i]+".js"))
;return this._addUrlArgsIfNecessaryToUrls(n)},t.prototype.requireToUrl=function(t){var n=t;return e.Utilities.isAbsolutePath(n)||(n=this._applyPaths(n)[0],e.Utilities.isAbsolutePath(n)||(n=this.options.baseUrl+n)),this._addUrlArgsIfNecessaryToUrl(n)},t.prototype.isBuild=function(){return this.options.isBuild},t.prototype.isDuplicateMessageIgnoredFor=function(e){return this.ignoreDuplicateModulesMap.hasOwnProperty(e)},t.prototype.getConfigForModule=function(e){if(this.options.config)return this.options.config[e]},t.prototype.shouldCatchError=function(){return this.options.catchError},t.prototype.shouldRecordStats=function(){return this.options.recordStats},t.prototype.onError=function(e){this.options.onError(e)},t}();e.Configuration=r}(s||(s={}));!function(e){var t=function(){function e(e){this._env=e,this._scriptLoader=null,this._callbackMap={}}return e.prototype.load=function(e,t,r,o){var a=this;this._scriptLoader||(this._scriptLoader=this._env.isWebWorker?new i:this._env.isNode?new s(this._env):new n)
;var u={callback:r,errorback:o};this._callbackMap.hasOwnProperty(t)?this._callbackMap[t].push(u):(this._callbackMap[t]=[u],this._scriptLoader.load(e,t,function(){return a.triggerCallback(t)},function(e){return a.triggerErrorback(t,e)}))},e.prototype.triggerCallback=function(e){var t=this._callbackMap[e];delete this._callbackMap[e];for(var n=0;n<t.length;n++)t[n].callback()},e.prototype.triggerErrorback=function(e,t){var n=this._callbackMap[e];delete this._callbackMap[e];for(var r=0;r<n.length;r++)n[r].errorback(t)},e}(),n=function(){function e(){}return e.prototype.attachListeners=function(e,t,n){var r=function(){e.removeEventListener("load",i),e.removeEventListener("error",s)},i=function(e){r(),t()},s=function(e){r(),n(e)};e.addEventListener("load",i),e.addEventListener("error",s)},e.prototype.load=function(e,t,n,r){var i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript"),this.attachListeners(i,n,r),i.setAttribute("src",t)
;var s=e.getConfig().getOptionsLiteral().cspNonce;s&&i.setAttribute("nonce",s),document.getElementsByTagName("head")[0].appendChild(i)},e}(),i=function(){function e(){}return e.prototype.load=function(e,t,n,r){try{importScripts(t),n()}catch(e){r(e)}},e}(),s=function(){function t(e){this._env=e,this._didInitialize=!1,this._didPatchNodeRequire=!1}return t.prototype._init=function(e){this._didInitialize||(this._didInitialize=!0,this._fs=e("fs"),this._vm=e("vm"),this._path=e("path"),this._crypto=e("crypto"))},t.prototype._initNodeRequire=function(e,t){var n=t.getConfig().getOptionsLiteral().nodeCachedData;if(n&&!this._didPatchNodeRequire){this._didPatchNodeRequire=!0;var i=this,s=e("module");s.prototype._compile=function(e,o){var a=s.wrap(e.replace(/^#!.*/,"")),u=t.getRecorder(),l=i._getCachedDataPath(n,o),c={filename:o};try{c.cachedData=i._fs.readFileSync(l),u.record(60,l)}catch(e){u.record(61,l)}var h=new i._vm.Script(a,c),d=h.runInThisContext(c),f=i._path.dirname(o),p=function(e){
var t=e.constructor,n=function(t){try{return e.require(t)}finally{}};return n.resolve=function(n){return t._resolveFilename(n,e)},n.main=process.mainModule,n.extensions=t._extensions,n.cache=t._cache,n}(this),m=[this.exports,p,this,o,f,process,r,Buffer],g=d.apply(this.exports,m);return setTimeout(function(){return i._handleCachedData(h,l,!c.cachedData,t)},Math.ceil(t.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*Math.random())),g}}},t.prototype.load=function(n,r,i,s){var o=this,a=n.getConfig().getOptionsLiteral(),u=a.nodeRequire||e.global.nodeRequire,l=a.nodeInstrumenter||function(e){return e};this._init(u),this._initNodeRequire(u,n);var c=n.getRecorder();if(/^node\|/.test(r)){var h=r.split("|"),d=null;try{d=u(h[1])}catch(e){return void s(e)}n.enqueueDefineAnonymousModule([],function(){return d}),i()}else{r=e.Utilities.fileUriToFilePath(this._env.isWindows,r)
;var f=this._path.normalize(r),p=this._getElectronRendererScriptPathOrUri(f),m=Boolean(a.nodeCachedData),g=m?this._getCachedDataPath(a.nodeCachedData,r):void 0;this._readSourceAndCachedData(f,g,c,function(e,r,a){if(e)s(e);else{var u;u=r.charCodeAt(0)===t._BOM?t._PREFIX+r.substring(1)+t._SUFFIX:t._PREFIX+r+t._SUFFIX,u=l(u,f);var c={filename:p,cachedData:a},h=o._createAndEvalScript(n,u,c,i,s);o._handleCachedData(h,g,m&&!a,n)}})}},t.prototype._createAndEvalScript=function(t,n,r,i,s){var o=t.getRecorder();o.record(31,r.filename);var a=new this._vm.Script(n,r),u=a.runInThisContext(r),l=t.getGlobalAMDDefineFunc(),c=!1,h=function(){return c=!0,l.apply(null,arguments)};return h.amd=l.amd,u.call(e.global,t.getGlobalAMDRequireFunc(),h,r.filename,this._path.dirname(r.filename)),o.record(32,r.filename),c?i():s(new Error("Didn't receive define call in "+r.filename+"!")),a},t.prototype._getElectronRendererScriptPathOrUri=function(e){if(!this._env.isElectronRenderer)return e;var t=e.match(/^([a-z])\:(.*)/i)
;return t?"file:///"+(t[1].toUpperCase()+":"+t[2]).replace(/\\/g,"/"):"file://"+e},t.prototype._getCachedDataPath=function(e,t){var n=this._crypto.createHash("md5").update(t,"utf8").update(e.seed,"utf8").digest("hex"),r=this._path.basename(t).replace(/\.js$/,"");return this._path.join(e.path,r+"-"+n+".code")},t.prototype._handleCachedData=function(e,t,n,r){var i=this;e.cachedDataRejected?this._fs.unlink(t,function(n){r.getRecorder().record(62,t),i._createAndWriteCachedData(e,t,r),n&&r.getConfig().onError(n)}):n&&this._createAndWriteCachedData(e,t,r)},t.prototype._createAndWriteCachedData=function(e,t,n){var r=this,i=Math.ceil(n.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),s=-1,o=0,a=function(){setTimeout(function(){var i=e.createCachedData();0===i.length||i.length===s||o>=5||(s=i.length,r._fs.writeFile(t,i,function(e){e&&n.getConfig().onError(e),n.getRecorder().record(63,t),a()}))},i*Math.pow(4,o++))};a()},t.prototype._readSourceAndCachedData=function(e,t,n,r){if(t){
var i,s,o=2,a=function(e){e?r(e):0==--o&&r(void 0,i,s)};this._fs.readFile(e,{encoding:"utf8"},function(e,t){i=t,a(e)}),this._fs.readFile(t,function(e,r){s=r&&r.length>0?r:void 0,a(),n.record(e?61:60,t)})}else this._fs.readFile(e,{encoding:"utf8"},r)},t._BOM=65279,t._PREFIX="(function (require, define, __filename, __dirname) { ",t._SUFFIX="\n});",t}();e.createScriptLoader=function(e){return new t(e)}}(s||(s={}));!function(e){var t=function(){function t(e){var t=e.lastIndexOf("/");this.fromModulePath=-1!==t?e.substr(0,t+1):""}return t._normalizeModuleId=function(e){var t,n=e;for(t=/\/\.\//;t.test(n);)n=n.replace(t,"/");for(n=n.replace(/^\.\//g,""),t=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;t.test(n);)n=n.replace(t,"/");return n=n.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,"")},t.prototype.resolveModule=function(n){var r=n
;return e.Utilities.isAbsolutePath(r)||(e.Utilities.startsWith(r,"./")||e.Utilities.startsWith(r,"../"))&&(r=t._normalizeModuleId(this.fromModulePath+r)),r},t.ROOT=new t(""),t}();e.ModuleIdResolver=t;var n=function(){function t(e,t,n,r,i,s){this.id=e,this.strId=t,this.dependencies=n,this._callback=r,this._errorback=i,this.moduleIdResolver=s,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return t._safeInvokeFunction=function(t,n){try{return{returnedValue:t.apply(e.global,n),producedError:null}}catch(e){return{returnedValue:null,producedError:e}}},t._invokeFactory=function(t,n,r,i){return t.isBuild()&&!e.Utilities.isAnonymousModule(n)?{returnedValue:null,producedError:null}:t.shouldCatchError()?this._safeInvokeFunction(r,i):{returnedValue:r.apply(e.global,i),producedError:null}},t.prototype.complete=function(n,r,i){this._isComplete=!0;var s=null;if(this._callback)if("function"==typeof this._callback){n.record(21,this.strId)
;var o=t._invokeFactory(r,this.strId,this._callback,i);s=o.producedError,n.record(22,this.strId),s||void 0===o.returnedValue||this.exportsPassedIn&&!e.Utilities.isEmpty(this.exports)||(this.exports=o.returnedValue)}else this.exports=this._callback;if(s){var a=e.ensureError(s);a.phase="factory",a.moduleId=this.strId,this.error=a,r.onError(a)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},t.prototype.onDependencyError=function(e){return this._isComplete=!0,this.error=e,!!this._errorback&&(this._errorback(e),!0)},t.prototype.isComplete=function(){return this._isComplete},t}();e.Module=n;var r=function(){function e(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return e.prototype.getMaxModuleId=function(){return this._nextId},e.prototype.getModuleId=function(e){var t=this._strModuleIdToIntModuleId.get(e);return void 0===t&&(t=this._nextId++,
this._strModuleIdToIntModuleId.set(e,t),this._intModuleIdToStrModuleId[t]=e),t},e.prototype.getStrModuleId=function(e){return this._intModuleIdToStrModuleId[e]},e}(),i=function(){function e(e){this.id=e}return e.EXPORTS=new e(0),e.MODULE=new e(1),e.REQUIRE=new e(2),e}();e.RegularDependency=i;var s=function(){return function(e,t,n){this.id=e,this.pluginId=t,this.pluginParam=n}}();e.PluginDependency=s;var o=function(){function o(t,n,i,s,o){void 0===o&&(o=0),this._env=t,this._scriptLoader=n,this._loaderAvailableTimestamp=o,this._defineFunc=i,this._requireFunc=s,this._moduleIdProvider=new r,this._config=new e.Configuration(this._env),this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return o.prototype.reset=function(){
return new o(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},o.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},o.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},o._findRelevantLocationInStack=function(e,t){for(var n=function(e){return e.replace(/\\/g,"/")},r=n(e),i=t.split(/\n/),s=0;s<i.length;s++){var o=i[s].match(/(.*):(\d+):(\d+)\)?$/);if(o){var a=o[1],u=o[2],l=o[3],c=Math.max(a.lastIndexOf(" ")+1,a.lastIndexOf("(")+1);if(a=a.substr(c),(a=n(a))===r){var h={line:parseInt(u,10),col:parseInt(l,10)};return 1===h.line&&(h.col-="(function (require, define, __filename, __dirname) { ".length),h}}}throw new Error("Could not correlate define call site for needle "+e)},o.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var e=[],t=0,n=0,r=this._modules2.length;n<r;n++){var i=this._modules2[n];if(i){
var s=this._buildInfoPath[i.id]||null,a=this._buildInfoDefineStack[i.id]||null,u=this._buildInfoDependencies[i.id];e[t++]={id:i.strId,path:s,defineLocation:s&&a?o._findRelevantLocationInStack(s,a):null,dependencies:u,shim:null,exports:i.exports}}}return e},o.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new e.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=e.NullLoaderEventRecorder.INSTANCE),this._recorder},o.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},o.prototype.enqueueDefineAnonymousModule=function(e,t){if(null!==this._currentAnnonymousDefineCall)throw new Error("Can only have one anonymous define call per script file");var n=null;this._config.isBuild()&&(n=new Error("StackLocation").stack||null),this._currentAnnonymousDefineCall={stack:n,dependencies:e,callback:t}},o.prototype.defineModule=function(e,r,i,s,o,a){var u=this;void 0===a&&(a=new t(e));var l=this._moduleIdProvider.getModuleId(e)
;if(this._modules2[l])this._config.isDuplicateMessageIgnoredFor(e)||console.warn("Duplicate definition of module '"+e+"'");else{var c=new n(l,e,this._normalizeDependencies(r,a),i,s,a);this._modules2[l]=c,this._config.isBuild()&&(this._buildInfoDefineStack[l]=o,this._buildInfoDependencies[l]=(c.dependencies||[]).map(function(e){return u._moduleIdProvider.getStrModuleId(e.id)})),this._resolve(c)}},o.prototype._normalizeDependency=function(e,t){if("exports"===e)return i.EXPORTS;if("module"===e)return i.MODULE;if("require"===e)return i.REQUIRE;var n=e.indexOf("!");if(n>=0){var r=t.resolveModule(e.substr(0,n)),o=t.resolveModule(e.substr(n+1)),a=this._moduleIdProvider.getModuleId(r+"!"+o),u=this._moduleIdProvider.getModuleId(r);return new s(a,u,o)}return new i(this._moduleIdProvider.getModuleId(t.resolveModule(e)))},o.prototype._normalizeDependencies=function(e,t){for(var n=[],r=0,i=0,s=e.length;i<s;i++)n[r++]=this._normalizeDependency(e[i],t);return n},o.prototype._relativeRequire=function(t,n,r,i){
if("string"==typeof n)return this.synchronousRequire(n,t);this.defineModule(e.Utilities.generateAnonymousModule(),n,r,i,null,t)},o.prototype.synchronousRequire=function(e,n){void 0===n&&(n=new t(e));var r=this._normalizeDependency(e,n),i=this._modules2[r.id];if(!i)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+e+"'. This is the first mention of this module!");if(!i.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+e+"'. This module has not been resolved completely yet.");if(i.error)throw i.error;return i.exports},o.prototype.configure=function(t,n){var r=this._config.shouldRecordStats();this._config=n?new e.Configuration(this._env,t):this._config.cloneAndMerge(t),this._config.shouldRecordStats()&&!r&&(this._recorder=null)},o.prototype.getConfig=function(){return this._config},o.prototype._onLoad=function(e){if(null!==this._currentAnnonymousDefineCall){var t=this._currentAnnonymousDefineCall
;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(e),t.dependencies,t.callback,null,t.stack)}},o.prototype._createLoadError=function(t,n){var r=this,i=this._moduleIdProvider.getStrModuleId(t),s=(this._inverseDependencies2[t]||[]).map(function(e){return r._moduleIdProvider.getStrModuleId(e)}),o=e.ensureError(n);return o.phase="loading",o.moduleId=i,o.neededBy=s,o},o.prototype._onLoadError=function(e,t){var r=this._createLoadError(e,t);this._modules2[e]||(this._modules2[e]=new n(e,this._moduleIdProvider.getStrModuleId(e),[],function(){},function(){},null));for(var i=[],s=0,o=this._moduleIdProvider.getMaxModuleId();s<o;s++)i[s]=!1;var a=!1,u=[];for(u.push(e),i[e]=!0;u.length>0;){var l=u.shift(),c=this._modules2[l];c&&(a=c.onDependencyError(r)||a);var h=this._inverseDependencies2[l];if(h)for(var s=0,o=h.length;s<o;s++){var d=h[s];i[d]||(u.push(d),i[d]=!0)}}a||this._config.onError(r)},o.prototype._hasDependencyPath=function(e,t){var n=this._modules2[e];if(!n)return!1
;for(var r=[],i=0,s=this._moduleIdProvider.getMaxModuleId();i<s;i++)r[i]=!1;var o=[];for(o.push(n),r[e]=!0;o.length>0;){var a=o.shift().dependencies;if(a)for(var i=0,s=a.length;i<s;i++){var u=a[i];if(u.id===t)return!0;var l=this._modules2[u.id];l&&!r[u.id]&&(r[u.id]=!0,o.push(l))}}return!1},o.prototype._findCyclePath=function(e,t,n){if(e===t||50===n)return[e];var r=this._modules2[e];if(!r)return null;var i=r.dependencies;if(i)for(var s=0,o=i.length;s<o;s++){var a=this._findCyclePath(i[s].id,t,n+1);if(null!==a)return a.push(e),a}return null},o.prototype._createRequire=function(t){var n=this,r=function(e,r,i){return n._relativeRequire(t,e,r,i)};return r.toUrl=function(e){return n._config.requireToUrl(t.resolveModule(e))},r.getStats=function(){return n.getLoaderEvents()},r.__$__nodeRequire=e.global.nodeRequire,r},o.prototype._loadModule=function(e){var t=this;if(!this._modules2[e]&&!this._knownModules2[e]){this._knownModules2[e]=!0;var n=this._moduleIdProvider.getStrModuleId(e),r=this._config.moduleIdToPaths(n)
;this._env.isNode&&(-1===n.indexOf("/")||/^@[^\/]+\/[^\/]+$/.test(n))&&r.push("node|"+n);var i=-1,s=function(n){if(++i>=r.length)t._onLoadError(e,n);else{var o=r[i],a=t.getRecorder();if(t._config.isBuild()&&"empty:"===o)return t._buildInfoPath[e]=o,t.defineModule(t._moduleIdProvider.getStrModuleId(e),[],null,null,null),void t._onLoad(e);a.record(10,o),t._scriptLoader.load(t,o,function(){t._config.isBuild()&&(t._buildInfoPath[e]=o),a.record(11,o),t._onLoad(e)},function(e){a.record(12,o),s(e)})}};s(null)}},o.prototype._loadPluginDependency=function(e,n){var r=this;if(!this._modules2[n.id]&&!this._knownModules2[n.id]){this._knownModules2[n.id]=!0;var i=function(e){r.defineModule(r._moduleIdProvider.getStrModuleId(n.id),[],e,null,null)};i.error=function(e){r._config.onError(r._createLoadError(n.id,e))},e.load(n.pluginParam,this._createRequire(t.ROOT),i,this._config.getOptionsLiteral())}},o.prototype._resolve=function(e){var t=this,n=e.dependencies;if(n)for(var r=0,o=n.length;r<o;r++){var a=n[r]
;if(a!==i.EXPORTS)if(a!==i.MODULE)if(a!==i.REQUIRE){var u=this._modules2[a.id];if(u&&u.isComplete()){if(u.error)return void e.onDependencyError(u.error);e.unresolvedDependenciesCount--}else if(this._hasDependencyPath(a.id,e.id)){console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(a.id)+"' and '"+this._moduleIdProvider.getStrModuleId(e.id)+"'. The cyclic path follows:");var l=this._findCyclePath(a.id,e.id,0)||[];l.reverse(),l.push(a.id),console.warn(l.map(function(e){return t._moduleIdProvider.getStrModuleId(e)}).join(" => \n")),e.unresolvedDependenciesCount--}else if(this._inverseDependencies2[a.id]=this._inverseDependencies2[a.id]||[],this._inverseDependencies2[a.id].push(e.id),a instanceof s){var c=this._modules2[a.pluginId];if(c&&c.isComplete()){this._loadPluginDependency(c.exports,a);continue}var h=this._inversePluginDependencies2.get(a.pluginId);h||(h=[],this._inversePluginDependencies2.set(a.pluginId,h)),h.push(a),this._loadModule(a.pluginId)
}else this._loadModule(a.id)}else e.unresolvedDependenciesCount--;else e.unresolvedDependenciesCount--;else e.exportsPassedIn=!0,e.unresolvedDependenciesCount--}0===e.unresolvedDependenciesCount&&this._onModuleComplete(e)},o.prototype._onModuleComplete=function(e){var t=this,n=this.getRecorder();if(!e.isComplete()){var r=e.dependencies,s=[];if(r)for(var o=0,a=r.length;o<a;o++){var u=r[o];if(u!==i.EXPORTS)if(u!==i.MODULE)if(u!==i.REQUIRE){var l=this._modules2[u.id];s[o]=l?l.exports:null}else s[o]=this._createRequire(e.moduleIdResolver);else s[o]={id:e.strId,config:function(){return t._config.getConfigForModule(e.strId)}};else s[o]=e.exports}e.complete(n,this._config,s);var c=this._inverseDependencies2[e.id];if(this._inverseDependencies2[e.id]=null,c)for(var o=0,a=c.length;o<a;o++){var h=c[o],d=this._modules2[h];d.unresolvedDependenciesCount--,0===d.unresolvedDependenciesCount&&this._onModuleComplete(d)}var f=this._inversePluginDependencies2.get(e.id);if(f){this._inversePluginDependencies2.delete(e.id)
;for(var o=0,a=f.length;o<a;o++)this._loadPluginDependency(e.exports,f[o])}}},o}();e.ModuleManager=o}(s||(s={}));var i,s;!function(e){function t(){if(void 0!==e.global.require||"undefined"!=typeof require){var t=e.global.require||require;if("function"==typeof t&&"function"==typeof t.resolve){var i=function(e){r.getRecorder().record(33,e);try{return t(e)}finally{r.getRecorder().record(34,e)}};e.global.nodeRequire=i,a.nodeRequire=i,a.__$__nodeRequire=i}}n.isNode&&!n.isElectronRenderer?(module.exports=a,require=a):(n.isElectronRenderer||(e.global.define=s),e.global.require=a)}var n=new e.Environment,r=null,s=function(e,t,n){"string"!=typeof e&&(n=t,t=e,e=null),"object"==typeof t&&Array.isArray(t)||(n=t,t=null),t||(t=["require","exports","module"]),e?r.defineModule(e,t,n,null,null):r.enqueueDefineAnonymousModule(t,n)};s.amd={jQuery:!0};var o=function(e,t){void 0===t&&(t=!1),r.configure(e,t)},a=function(){if(1===arguments.length){
if(arguments[0]instanceof Object&&!Array.isArray(arguments[0]))return void o(arguments[0]);if("string"==typeof arguments[0])return r.synchronousRequire(arguments[0])}if(2!==arguments.length&&3!==arguments.length||!Array.isArray(arguments[0]))throw new Error("Unrecognized require call");r.defineModule(e.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null)};a.config=o,a.getConfig=function(){return r.getConfig().getOptionsLiteral()},a.reset=function(){r=r.reset()},a.getBuildInfo=function(){return r.getBuildInfo()},a.getStats=function(){return r.getLoaderEvents()},a.define=function(){return s.apply(null,arguments)},e.init=t,"function"==typeof e.global.define&&e.global.define.amd||(r=new e.ModuleManager(n,e.createScriptLoader(n),s,a,e.Utilities.getHighPerformanceTimestamp()),void 0!==e.global.require&&"function"!=typeof e.global.require&&a.config(e.global.require),(i=function(){return s.apply(null,arguments)}).amd=s.amd,"undefined"==typeof doNotInitLoader&&t())}(s||(s={})),
i(e[6],t([1,0]),function(e,t){"use strict";function n(e){return e instanceof Error&&e.name===i&&e.message===i}Object.defineProperty(t,"__esModule",{value:!0});class r{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=r,t.errorHandler=new r,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},t.onUnexpectedError=function(e){n(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){
n(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:n}=e;return{$isError:!0,name:t,message:n,stack:e.stacktrace||e.stack}}return e};const i="Canceled";t.isPromiseCanceledError=n,t.canceled=function(){const e=new Error(i);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"}});var o=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))(function(i,s){function o(e){try{u(r.next(e))}catch(e){s(e)}}
function a(e){try{u(r.throw(e))}catch(e){s(e)}}function u(e){e.done?i(e.value):new n(function(t){t(e.value)}).then(o,a)}u((r=r.apply(e,t||[])).next())})};i(e[13],t([1,0,6]),function(e,t,n){"use strict";function r(e,t){let n=0,r=e.length;if(0===r)return 0;for(;n<r;){const i=Math.floor((n+r)/2);t(e[i])?r=i:n=i+1}return n}function i(e,t){return s(e,t,0,e.length-1,[]),e}function s(e,t,n,r,i){if(r<=n)return;const o=n+(r-n)/2|0;s(e,t,n,o,i),s(e,t,o+1,r,i),t(e[o],e[o+1])<=0||function(e,t,n,r,i,s){let o=n,a=r+1;for(let t=n;t<=i;t++)s[t]=e[t];for(let u=n;u<=i;u++)o>r?e[u]=s[a++]:a>i?e[u]=s[o++]:t(s[a],s[o])<0?e[u]=s[a++]:e[u]=s[o++]}(e,t,n,o,r,i)}function a(e,t,n){function r(e,t,n){if(0===t&&0===n.length)return;const r=i[i.length-1];r&&r.start+r.deleteCount===e?(r.deleteCount+=t,r.toInsert.push(...n)):i.push({start:e,deleteCount:t,toInsert:n})}const i=[];let s=0,o=0;for(;;){if(s===e.length){r(s,0,t.slice(o));break}if(o===t.length){r(s,e.length-s,[]);break}const i=e[s],a=t[o],u=n(i,a);0===u?(s+=1,o+=1):u<0?(r(s,1,[]),
s+=1):u>0&&(r(s,0,[a]),o+=1)}return i}function u(e,t,n,i,s){for(const o=n.length;i<s;i++){const s=e[i];if(t(s,n[o-1])<0){n.pop();const e=r(n,e=>t(s,e)<0);n.splice(e,0,s)}}}function l(e,t){for(let n=0;n<e.length;n++){if(t(e[n]))return n}return-1}Object.defineProperty(t,"__esModule",{value:!0}),t.tail=function(e,t=0){return e[e.length-(1+t)]},t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call");return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,n=((e,t)=>e===t)){if(e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;for(let r=0,i=e.length;r<i;r++)if(!n(e[r],t[r]))return!1;return!0},t.binarySearch=function(e,t,n){let r=0,i=e.length-1;for(;r<=i;){const s=(r+i)/2|0,o=n(e[s],t);if(o<0)r=s+1;else{if(!(o>0))return s;i=s-1}}return-(r+1)},t.findFirstInSorted=r,t.mergeSort=i,t.groupBy=function(e,t){const n=[];let r=void 0;for(const s of i(e.slice(0),t))r&&0===t(r[0],s)?r.push(s):(r=[s],n.push(r));return n},t.sortedDiff=a,t.delta=function(e,t,n){const r=a(e,t,n),i=[],s=[]
;for(const t of r)i.push(...e.slice(t.start,t.start+t.deleteCount)),s.push(...t.toInsert);return{removed:i,added:s}},t.top=function(e,t,n){if(0===n)return[];const r=e.slice(0,n).sort(t);return u(e,t,r,n,e.length),r},t.topAsync=function(e,t,r,i,s){return 0===r?Promise.resolve([]):new Promise((a,l)=>{(()=>o(this,void 0,void 0,function*(){const o=e.length,a=e.slice(0,r).sort(t);for(let l=r,c=Math.min(r+i,o);l<o;l=c,c=Math.min(c+i,o)){if(l>r&&(yield new Promise(e=>setTimeout(e))),s&&s.isCancellationRequested)throw n.canceled();u(e,t,a,l,c)}return a}))().then(a,l)})},t.coalesce=function(e){return e?e.filter(e=>!!e):e},t.coalesceInPlace=function(e){if(!e)return;let t=0;for(let n=0;n<e.length;n++)e[n]&&(e[t]=e[n],t+=1);e.length=t},t.move=function(e,t,n){e.splice(n,0,e.splice(t,1)[0])},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){return Array.isArray(e)&&e.length>0},t.distinct=function(e,t){if(!t)return e.filter((t,n)=>e.indexOf(t)===n);const n=Object.create(null)
;return e.filter(e=>{const r=t(e);return!n[r]&&(n[r]=!0,!0)})},t.distinctES6=function(e){const t=new Set;return e.filter(e=>!t.has(e)&&(t.add(e),!0))},t.uniqueFilter=function(e){const t=Object.create(null);return n=>{const r=e(n);return!t[r]&&(t[r]=!0,!0)}},t.lastIndex=function(e,t){for(let n=e.length-1;n>=0;n--)if(t(e[n]))return n;return-1},t.firstIndex=l,t.first=function(e,t,n){const r=l(e,t);return r<0?n:e[r]},t.commonPrefixLength=function(e,t,n=((e,t)=>e===t)){let r=0;for(let i=0,s=Math.min(e.length,t.length);i<s&&n(e[i],t[i]);i++)r++;return r},t.flatten=function(e){return[].concat(...e)},t.range=function(e,t){let n="number"==typeof t?e:0;"number"==typeof t?n=e:(n=0,t=e);const r=[];if(n<=t)for(let e=n;e<t;e++)r.push(e);else for(let e=n;e>t;e--)r.push(e);return r},t.fill=function(e,t,n=[]){for(let r=0;r<e;r++)n[r]=t;return n},t.index=function(e,t,n=(e=>e)){return e.reduce((e,r)=>{const i=t(r);return e[i]=n(r,e[i]),e},Object.create(null))},t.insert=function(e,t){return e.push(t),()=>{const n=e.indexOf(t)
;n>-1&&e.splice(n,1)}},t.arrayInsert=function(e,t,n){const r=e.slice(0,t),i=e.slice(t);return r.concat(n,i)},t.shuffle=function(e,t){let n;if("number"==typeof t){let e=t;n=(()=>{const t=179426549*Math.sin(e++);return t-Math.floor(t)})}else n=Math.random;for(let t=e.length-1;t>0;t-=1){const r=Math.floor(n()*(t+1)),i=e[t];e[t]=e[r],e[r]=i}},t.pushToStart=function(e,t){const n=e.indexOf(t);n>-1&&(e.splice(n,1),e.unshift(t))},t.pushToEnd=function(e,t){const n=e.indexOf(t);n>-1&&(e.splice(n,1),e.push(t))},t.find=function(e,t){for(let n=0;n<e.length;n++){const r=e[n];if(t(r,n,e))return r}},t.mapArrayOrNot=function(e,t){return Array.isArray(e)?e.map(t):t(e)},t.asArray=function(e){return Array.isArray(e)?e:[e]}}),i(e[7],t([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=function(e){const t=this;let n,r=!1;return function(){return r?n:(r=!0,n=e.apply(t,arguments))}}}),i(e[10],t([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FIN={done:!0,
value:void 0};var n;!function(e){const n={next:()=>t.FIN};e.empty=function(){return n},e.single=function(e){let n=!1;return{next:()=>n?t.FIN:(n=!0,{done:!1,value:e})}},e.fromArray=function(e,n=0,r=e.length){return{next:()=>n>=r?t.FIN:{done:!1,value:e[n++]}}},e.from=function(t){return t?Array.isArray(t)?e.fromArray(t):t:e.empty()},e.map=function(e,n){return{next(){const r=e.next();return r.done?t.FIN:{done:!1,value:n(r.value)}}}},e.filter=function(e,n){return{next(){for(;;){const r=e.next();if(r.done)return t.FIN;if(n(r.value))return{done:!1,value:r.value}}}}},e.forEach=function(e,t){for(let n=e.next();!n.done;n=e.next())t(n.value)},e.collect=function(e,t=Number.POSITIVE_INFINITY){const n=[];if(0===t)return n;let r=0;for(let i=e.next();!(i.done||(n.push(i.value),++r>=t));i=e.next());return n},e.concat=function(...e){let n=0;return{next(){if(n>=e.length)return t.FIN;const r=e[n].next();return r.done?(n++,this.next()):r}}}}(n=t.Iterator||(t.Iterator={})),t.getSequenceIterator=function(e){
return Array.isArray(e)?n.fromArray(e):e};class r{constructor(e,t=0,n=e.length,r=t-1){this.items=e,this.start=t,this.end=n,this.index=r}first(){return this.index=this.start,this.current()}next(){return this.index=Math.min(this.index+1,this.end),this.current()}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}}t.ArrayIterator=r;class i extends r{constructor(e,t=0,n=e.length,r=t-1){super(e,t,n,r)}current(){return super.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}parent(){return null}}t.ArrayNavigator=i;class s{constructor(e,t){this.iterator=e,this.fn=t}next(){return this.fn(this.iterator.next())}}t.MappedIterator=s;class o extends s{constructor(e,t){super(e,t),this.navigator=e}current(){return this.fn(this.navigator.current())}previous(){return this.fn(this.navigator.previous())}parent(){
return this.fn(this.navigator.parent())}first(){return this.fn(this.navigator.first())}last(){return this.fn(this.navigator.last())}next(){return this.fn(this.navigator.next())}}t.MappedNavigator=o}),i(e[9],t([1,0,7]),function(e,t,n){"use strict";function r(e){if(o&&e&&e!==l.None)try{e[a]=!0}catch(e){}}function i(e){if(!o)return e;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[a]||console.log(t)},3e3),e}function s(e){return Array.isArray(e)?(e.forEach(e=>{e&&(r(e),e.dispose())}),[]):e?(r(e),e.dispose(),e):void 0}Object.defineProperty(t,"__esModule",{value:!0});const o=!1,a="__is_disposable_tracked__";t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=s,t.combinedDisposable=function(...e){return e.forEach(r),i({dispose:()=>s(e)})},t.toDisposable=function(e){const t=i({dispose:()=>{r(t),e()}});return t};class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(r(this),this._isDisposed=!0,
this.clear())}clear(){this._toDispose.forEach(e=>e.dispose()),this._toDispose.clear()}add(e){if(!e)return e;if(e===this)throw new Error("Cannot register a disposable on itself!");return r(e),this._isDisposed?(console.warn(new Error("Registering disposable on object that has already been disposed of").stack),e.dispose()):this._toDispose.add(e),e}}t.DisposableStore=u;class l{constructor(){this._store=new u,i(this)}dispose(){r(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}l.None=Object.freeze({dispose(){}}),t.Disposable=l;class c{constructor(){this._isDisposed=!1,i(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&r(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,r(this),this._value&&this._value.dispose(),this._value=void 0}}t.MutableDisposable=c;class h extends l{constructor(e){super(),
this._hasBeenAcquired=!1,this._value=e}acquire(){if(this._hasBeenAcquired)throw new Error("This disposable has already been acquired");this._hasBeenAcquired=!0;const e=this._value;return this._value=void 0,e}dispose(){super.dispose(),this._hasBeenAcquired||(this._hasBeenAcquired=!0,this._value.dispose(),this._value=void 0)}}t.UnownedDisposable=h;class d{constructor(){this.references=new Map}acquire(e){let t=this.references.get(e);t||(t={counter:0,object:this.createReferencedObject(e)},this.references.set(e,t));const{object:r}=t,i=n.once(()=>{0==--t.counter&&(this.destroyReferencedObject(e,t.object),this.references.delete(e))});return t.counter++,{object:r,dispose:i}}}t.ReferenceCollection=d;class f{constructor(e){this.object=e}dispose(){}}t.ImmortalReference=f}),i(e[19],t([1,0,10]),function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class r{constructor(e){this.element=e,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class i{constructor(){
this._first=r.Undefined,this._last=r.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===r.Undefined}clear(){this._first=r.Undefined,this._last=r.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const n=new r(e);if(this._first===r.Undefined)this._first=n,this._last=n;else if(t){const e=this._last;this._last=n,n.prev=e,e.next=n}else{const e=this._first;this._first=n,n.next=e,e.prev=n}this._size+=1;let i=!1;return()=>{i||(i=!0,this._remove(n))}}shift(){if(this._first!==r.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==r.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){if(e.prev!==r.Undefined&&e.next!==r.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===r.Undefined&&e.next===r.Undefined?(this._first=r.Undefined,this._last=r.Undefined):e.next===r.Undefined?(this._last=this._last.prev,
this._last.next=r.Undefined):e.prev===r.Undefined&&(this._first=this._first.next,this._first.prev=r.Undefined);this._size-=1}iterator(){let e,t=this._first;return{next:()=>t===r.Undefined?n.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}toArray(){const e=[];for(let t=this._first;t!==r.Undefined;t=t.next)e.push(t.element);return e}}t.LinkedList=i}),i(e[11],t([1,0,6,7,9,19]),function(e,t,n,r,i,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var a;!function(e){function t(e){return(t,n=null,r)=>{let i,s=!1;return i=e(e=>{if(!s)return i?i.dispose():s=!0,t.call(n,e)},null,r),s&&i.dispose(),i}}function n(e,t){return a((n,r=null,i)=>e(e=>n.call(r,t(e)),null,i))}function r(e,t){return a((n,r=null,i)=>e(e=>{t(e),n.call(r,e)},null,i))}function s(e,t){return a((n,r=null,i)=>e(e=>t(e)&&n.call(r,e),null,i))}function o(e,t,r){let i=r;return n(e,e=>i=t(i,e))}function a(e){let t;const n=new c({onFirstListenerAdd(){t=e(n.fire,n)},onLastListenerRemove(){t.dispose()}});return n.event}
function u(e){let t,n=!0;return s(e,e=>{const r=n||e!==t;return n=!1,t=e,r})}e.None=(()=>i.Disposable.None),e.once=t,e.map=n,e.forEach=r,e.filter=s,e.signal=function(e){return e},e.any=function(...e){return(t,n=null,r)=>i.combinedDisposable(...e.map(e=>e(e=>t.call(n,e),null,r)))},e.reduce=o,e.snapshot=a,e.debounce=function(e,t,n=100,r=!1,i){let s,o=void 0,a=void 0,u=0;const l=new c({leakWarningThreshold:i,onFirstListenerAdd(){s=e(e=>{u++,o=t(o,e),r&&!a&&l.fire(o),clearTimeout(a),a=setTimeout(()=>{const e=o;o=void 0,a=void 0,(!r||u>1)&&l.fire(e),u=0},n)})},onLastListenerRemove(){s.dispose()}});return l.event},e.stopwatch=function(e){const r=(new Date).getTime();return n(t(e),e=>(new Date).getTime()-r)},e.latch=u,e.buffer=function(e,t=!1,n=[]){let r=n.slice(),i=e(e=>{r?r.push(e):o.fire(e)});const s=()=>{r&&r.forEach(e=>o.fire(e)),r=null},o=new c({onFirstListenerAdd(){i||(i=e(e=>o.fire(e)))},onFirstListenerDidAdd(){r&&(t?setTimeout(s):s())},onLastListenerRemove(){i&&i.dispose(),i=null}});return o.event};class l{
constructor(e){this.event=e}map(e){return new l(n(this.event,e))}forEach(e){return new l(r(this.event,e))}filter(e){return new l(s(this.event,e))}reduce(e,t){return new l(o(this.event,e,t))}latch(){return new l(u(this.event))}on(e,t,n){return this.event(e,t,n)}once(e,n,r){return t(this.event)(e,n,r)}}e.chain=function(e){return new l(e)},e.fromNodeEventEmitter=function(e,t,n=(e=>e)){const r=(...e)=>i.fire(n(...e)),i=new c({onFirstListenerAdd:()=>e.on(t,r),onLastListenerRemove:()=>e.removeListener(t,r)});return i.event},e.fromDOMEventEmitter=function(e,t,n=(e=>e)){const r=(...e)=>i.fire(n(...e)),i=new c({onFirstListenerAdd:()=>e.addEventListener(t,r),onLastListenerRemove:()=>e.removeEventListener(t,r)});return i.event},e.fromPromise=function(e){const t=new c;let n=!1;return e.then(void 0,()=>null).then(()=>{n?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),n=!0,t.event},e.toPromise=function(e){return new Promise(n=>t(e)(n))}}(a=t.Event||(t.Event={}));let u=-1;t.setGlobalLeakWarningThreshold=function(e){
const t=u;return u=e,{dispose(){u=t}}};class l{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=u;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map);const n=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(n)||0;if(this._stacks.set(n,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*t;let n,r=0;this._stacks.forEach((e,t)=>{(!n||r<e)&&(n=t,r=e)}),console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const e=this._stacks.get(n)||0;this._stacks.set(n,e-1)}}}class c{constructor(e){this._disposed=!1,this._options=e,this._leakageMon=u>0?new l(this._options&&this._options.leakWarningThreshold):void 0}get event(){return this._event||(this._event=((e,t,n)=>{
this._listeners||(this._listeners=new s.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(t?[e,t]:e);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,e,t);let a;this._leakageMon&&(a=this._leakageMon.check(this._listeners.size));let u;return u={dispose:()=>{if(a&&a(),u.dispose=c._noop,!this._disposed&&(o(),this._options&&this._options.onLastListenerRemove)){this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},n instanceof i.DisposableStore?n.add(u):Array.isArray(n)&&n.push(u),u})),this._event}fire(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let t=this._listeners.iterator(),n=t.next();!n.done;n=t.next())this._deliveryQueue.push([n.value,e]);for(;this._deliveryQueue.size>0;){
const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){n.onUnexpectedError(e)}}}}dispose(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0}}c._noop=function(){},t.Emitter=c;class h extends c{constructor(e){super(e),this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=e&&e.merge}pause(){this._isPaused++}resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=this._eventQueue.toArray();this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}}t.PauseableEmitter=h;class d extends c{fireAsync(e){return o(this,void 0,void 0,function*(){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=[])
;for(let t=this._listeners.iterator(),n=t.next();!n.done;n=t.next()){const t=[];this._asyncDeliveryQueue.push([n.value,e(t,"function"==typeof n.value?n.value:n.value[0]),t])}for(;this._asyncDeliveryQueue.length>0;){const[e,t,r]=this._asyncDeliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){n.onUnexpectedError(e);continue}Object.freeze(r),yield Promise.all(r)}}})}}t.AsyncEmitter=d;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);return i.toDisposable(r.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}
hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=f;class p{constructor(){this.buffers=[]}wrapEvent(e){return(t,n,r)=>e(e=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>t.call(n,e)):t.call(n,e)},void 0,r)}bufferEvents(e){const t=[];this.buffers.push(t);const n=e();return this.buffers.pop(),t.forEach(e=>e()),n}}t.EventBufferer=p;class m{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=i.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}
t.Relay=m}),i(e[16],t([1,0,11]),function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const r=Object.freeze(function(e,t){const n=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(n)}}});var i;!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||t instanceof s||!(!t||"object"!=typeof t)&&"boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})}(i=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){
this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class o{constructor(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=i.Cancelled}dispose(){this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=i.None}}t.CancellationTokenSource=o}),i(e[18],t([1,0,16,6,11,9]),function(e,t,n,r,i,s){"use strict";function a(e){return e&&"function"==typeof e.then}function u(e){const t=new n.CancellationTokenSource,i=e(t.token),s=new Promise((e,n)=>{t.token.onCancellationRequested(()=>{n(r.canceled())}),Promise.resolve(i).then(n=>{t.dispose(),e(n)},e=>{t.dispose(),n(e)})});return new class{cancel(){t.cancel()}then(e,t){return s.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return s.finally(e)}}}function l(e,t){
return t?new Promise((n,i)=>{const s=setTimeout(n,e);t.onCancellationRequested(()=>{clearTimeout(s),i(r.canceled())})}):u(t=>l(e,t))}function c(e){function t(s){void 0!==s&&null!==s&&n.push(s);const o=r<i?e[r++]():null;return o?o.then(t):Promise.resolve(n)}const n=[];let r=0;const i=e.length;return Promise.resolve(null).then(t)}Object.defineProperty(t,"__esModule",{value:!0}),t.isThenable=a,t.createCancelablePromise=u,t.raceCancellation=function(e,t,n){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(n)))])},t.asPromise=function(e){return new Promise((t,n)=>{const r=e();a(r)?r.then(t,n):t(r)})};class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}
return new Promise((e,t)=>{this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=h;class d{constructor(){this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e())}}t.Sequencer=d;class f{constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((e,t)=>{this.doResolve=e,this.doReject=t}).then(()=>{this.completionPromise=null,this.doResolve=null;const e=this.task;return this.task=null,e()})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject(r.canceled()),this.completionPromise=null)}cancelTimeout(){
null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=f;class p{constructor(e){this.delayer=new f(e),this.throttler=new h}trigger(e,t){return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=p;class m{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=m,t.timeout=l,t.disposableTimeout=function(e,t=0){const n=setTimeout(e,t);return s.toDisposable(()=>clearTimeout(n))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=c,t.first=function(e,t=(e=>!!e),n=null){let r=0;const i=e.length,s=()=>{if(r>=i)return Promise.resolve(n);const o=e[r++];return Promise.resolve(o()).then(e=>t(e)?Promise.resolve(e):s())};return s()};class g{constructor(e){this._size=0,
this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new i.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(e){return this._size++,new Promise((t,n)=>{this.outstandingPromises.push({factory:e,c:t,e:n}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=g;class _ extends g{constructor(){super(1)}}t.Queue=_;class v{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){const e=new _;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),this.queues.set(t,e)}return this.queues.get(t)}}t.ResourceQueue=v;class y{
constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setTimeout(()=>{this._token=-1,e()},t)}setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}}t.TimeoutTimer=y;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}}t.IntervalTimer=b;class w{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,e)}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,
this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=w;class x extends w{constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=x,function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,timeRemaining:()=>15});t.runWhenIdle=(t=>{const n=setTimeout(()=>t(e));let r=!1;return{dispose(){r||(r=!0,clearTimeout(n))}}})}else t.runWhenIdle=((e,t)=>{const n=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let r=!1;return{dispose(){r||(r=!0,cancelIdleCallback(n))}}})}();class C{constructor(e){this._didRun=!1,this._executor=(()=>{try{this._value=e()}catch(e){this._error=e}finally{this._didRun=!0}}),this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}getValue(){if(this._didRun||(this._handle.dispose(),
this._executor()),this._error)throw this._error;return this._value}}t.IdleValue=C,t.retry=function(e,t,n){return o(this,void 0,void 0,function*(){let r;for(let i=0;i<n;i++)try{return yield e()}catch(e){r=e,yield l(t)}return Promise.reject(r)})}}),i(e[8],t([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});!function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.userData="vscode-userdata"}(t.Schemas||(t.Schemas={}))}),i(e[2],t([1,0]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});let n=!1,r=!1,i=!1,s=!1,o=!1,a=void 0,u="en",l=void 0,c=void 0;const h="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||h){
if("object"==typeof process){n="win32"===process.platform,r="darwin"===process.platform,i="linux"===process.platform,a="en",u="en";const e=process.env.VSCODE_NLS_CONFIG;if(e)try{const t=JSON.parse(e),n=t.availableLanguages["*"];a=t.locale,u=n||"en",l=t._translationsConfigFile}catch(e){}s=!0}}else c=navigator.userAgent,n=c.indexOf("Windows")>=0,r=c.indexOf("Macintosh")>=0,i=c.indexOf("Linux")>=0,o=!0,u=a=navigator.language;!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let d=0;s&&(r?d=1:n?d=3:i&&(d=2)),t.isWindows=n,t.isMacintosh=r,t.isLinux=i,t.isNative=s,t.isWeb=o,t.platform=d,t.userAgent=c,t.isRootUser=function(){return s&&!n&&0===process.getuid()},t.language=u;!function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){
return 2===t.language.length?"en"===t.language:t.language.length>=3&&"e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2]},e.isDefault=function(){return"en"===t.language}}(t.Language||(t.Language={})),t.locale=a,t.translationsConfigFile=l;const f="object"==typeof self?self:"object"==typeof global?global:{};t.globals=f;let p=null;t.setImmediate=function(e){return null===p&&(p=t.globals.setImmediate?t.globals.setImmediate.bind(t.globals):"undefined"!=typeof process&&"function"==typeof process.nextTick?process.nextTick.bind(process):t.globals.setTimeout.bind(t.globals)),p(e)};!function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=r?2:n?1:3}),i(e[17],t([1,0,2]),function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const r="undefined"==typeof process?{cwd:()=>"/",env:Object.create(null),get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},nextTick:e=>n.setImmediate(e)}:process
;t.cwd=r.cwd,t.env=r.env,t.platform=r.platform,t.nextTick=r.nextTick}),i(e[4],t([1,0,17]),function(e,t,n){"use strict";function r(e,t){if("string"!=typeof e)throw new g(t,"string",e)}function i(e){return e===p||e===m}function s(e){return e===p}function o(e){return e>=l&&e<=h||e>=c&&e<=d}function a(e,t,n,r){let i,s="",o=0,a=-1,u=0;for(let l=0;l<=e.length;++l){if(l<e.length)i=e.charCodeAt(l);else{if(r(i))break;i=p}if(r(i)){if(a===l-1||1===u);else if(a!==l-1&&2===u){if(s.length<2||2!==o||s.charCodeAt(s.length-1)!==f||s.charCodeAt(s.length-2)!==f){if(s.length>2){const e=s.lastIndexOf(n);-1===e?(s="",o=0):o=(s=s.slice(0,e)).length-1-s.lastIndexOf(n),a=l,u=0;continue}if(2===s.length||1===s.length){s="",o=0,a=l,u=0;continue}}t&&(s.length>0?s+=`${n}..`:s="..",o=2)}else s.length>0?s+=n+e.slice(a+1,l):s=e.slice(a+1,l),o=l-a-1;a=l,u=0}else i===f&&-1!==u?++u:u=-1}return s}function u(e,t){const n=t.dir||t.root,r=t.base||(t.name||"")+(t.ext||"");return n?n===t.root?n+r:n+e+r:r}Object.defineProperty(t,"__esModule",{value:!0
});const l=65,c=97,h=90,d=122,f=46,p=47,m=92;class g extends Error{constructor(e,t,n){let r;"string"==typeof t&&0===t.indexOf("not ")?(r="must not be",t=t.replace(/^not /,"")):r="must be";let i=`The "${e}" ${-1!==e.indexOf(".")?"property":"argument"} ${r} of type ${t}`;super(i+=`. Received type ${typeof n}`)}}t.win32={resolve(...e){let t="",s="",u=!1;for(let a=e.length-1;a>=-1;a--){let l;if(a>=0?l=e[a]:t?void 0!==(l=n.env["="+t]||n.cwd())&&l.slice(0,3).toLowerCase()===t.toLowerCase()+"\\"||(l=t+"\\"):l=n.cwd(),r(l,"path"),0===l.length)continue;const c=l.length;let h=0,d="",f=!1;const p=l.charCodeAt(0);if(c>1)if(i(p))if(f=!0,i(l.charCodeAt(1))){let e=2,t=e;for(;e<c&&!i(l.charCodeAt(e));++e);if(e<c&&e!==t){const n=l.slice(t,e);for(t=e;e<c&&i(l.charCodeAt(e));++e);if(e<c&&e!==t){for(t=e;e<c&&!i(l.charCodeAt(e));++e);e===c?(d="\\\\"+n+"\\"+l.slice(t),h=e):e!==t&&(d="\\\\"+n+"\\"+l.slice(t,e),h=e)}}}else h=1;else o(p)&&58===l.charCodeAt(1)&&(d=l.slice(0,2),h=2,c>2&&i(l.charCodeAt(2))&&(f=!0,h=3));else i(p)&&(h=1,
f=!0);if(!(d.length>0&&t.length>0&&d.toLowerCase()!==t.toLowerCase())&&(0===t.length&&d.length>0&&(t=d),u||(s=l.slice(h)+"\\"+s,u=f),t.length>0&&u))break}return s=a(s,!u,"\\",i),t+(u?"\\":"")+s||"."},normalize(e){r(e,"path");const t=e.length;if(0===t)return".";let n,s=0,u=!1;const l=e.charCodeAt(0);if(t>1)if(i(l))if(u=!0,i(e.charCodeAt(1))){let r=2,o=r;for(;r<t&&!i(e.charCodeAt(r));++r);if(r<t&&r!==o){const a=e.slice(o,r);for(o=r;r<t&&i(e.charCodeAt(r));++r);if(r<t&&r!==o){for(o=r;r<t&&!i(e.charCodeAt(r));++r);if(r===t)return"\\\\"+a+"\\"+e.slice(o)+"\\";r!==o&&(n="\\\\"+a+"\\"+e.slice(o,r),s=r)}}}else s=1;else o(l)&&58===e.charCodeAt(1)&&(n=e.slice(0,2),s=2,t>2&&i(e.charCodeAt(2))&&(u=!0,s=3));else if(i(l))return"\\";let c;return 0!==(c=s<t?a(e.slice(s),!u,"\\",i):"").length||u||(c="."),c.length>0&&i(e.charCodeAt(t-1))&&(c+="\\"),void 0===n?u?c.length>0?"\\"+c:"\\":c.length>0?c:"":u?c.length>0?n+"\\"+c:n+"\\":c.length>0?n+c:n},isAbsolute(e){r(e,"path");const t=e.length;if(0===t)return!1
;const n=e.charCodeAt(0);return!!i(n)||!!(o(n)&&t>2&&58===e.charCodeAt(1)&&i(e.charCodeAt(2)))},join(...e){if(0===e.length)return".";let n,s;for(let t=0;t<e.length;++t){const i=e[t];r(i,"path"),i.length>0&&(void 0===n?n=s=i:n+="\\"+i)}if(void 0===n)return".";let o=!0,a=0;if("string"==typeof s&&i(s.charCodeAt(0))){++a;const e=s.length;e>1&&i(s.charCodeAt(1))&&(++a,e>2&&(i(s.charCodeAt(2))?++a:o=!1))}if(o){for(;a<n.length&&i(n.charCodeAt(a));++a);a>=2&&(n="\\"+n.slice(a))}return t.win32.normalize(n)},relative(e,n){if(r(e,"from"),r(n,"to"),e===n)return"";const i=t.win32.resolve(e),s=t.win32.resolve(n);if(i===s)return"";if(e=i.toLowerCase(),n=s.toLowerCase(),e===n)return"";let o=0;for(;o<e.length&&e.charCodeAt(o)===m;++o);let a=e.length;for(;a-1>o&&e.charCodeAt(a-1)===m;--a);const u=a-o;let l=0;for(;l<n.length&&n.charCodeAt(l)===m;++l);let c=n.length;for(;c-1>l&&n.charCodeAt(c-1)===m;--c);const h=c-l,d=u<h?u:h;let f=-1,p=0;for(;p<=d;++p){if(p===d){if(h>d){if(n.charCodeAt(l+p)===m)return s.slice(l+p+1)
;if(2===p)return s.slice(l+p)}u>d&&(e.charCodeAt(o+p)===m?f=p:2===p&&(f=3));break}const t=e.charCodeAt(o+p);if(t!==n.charCodeAt(l+p))break;t===m&&(f=p)}if(p!==d&&-1===f)return s;let g="";for(-1===f&&(f=0),p=o+f+1;p<=a;++p)p!==a&&e.charCodeAt(p)!==m||(0===g.length?g+="..":g+="\\..");return g.length>0?g+s.slice(l+f,c):(l+=f,s.charCodeAt(l)===m&&++l,s.slice(l,c))},toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return"";const n=t.win32.resolve(e);if(n.length>=3)if(n.charCodeAt(0)===m){if(n.charCodeAt(1)===m){const e=n.charCodeAt(2);if(63!==e&&e!==f)return"\\\\?\\UNC\\"+n.slice(2)}}else if(o(n.charCodeAt(0))&&58===n.charCodeAt(1)&&n.charCodeAt(2)===m)return"\\\\?\\"+n;return e},dirname(e){r(e,"path");const t=e.length;if(0===t)return".";let n=-1,s=-1,a=!0,u=0;const l=e.charCodeAt(0);if(t>1)if(i(l)){if(n=u=1,i(e.charCodeAt(1))){let r=2,s=r;for(;r<t&&!i(e.charCodeAt(r));++r);if(r<t&&r!==s){for(s=r;r<t&&i(e.charCodeAt(r));++r);if(r<t&&r!==s){for(s=r;r<t&&!i(e.charCodeAt(r));++r);if(r===t)return e
;r!==s&&(n=u=r+1)}}}}else o(l)&&58===e.charCodeAt(1)&&(n=u=2,t>2&&i(e.charCodeAt(2))&&(n=u=3));else if(i(l))return e;for(let n=t-1;n>=u;--n)if(i(e.charCodeAt(n))){if(!a){s=n;break}}else a=!1;if(-1===s){if(-1===n)return".";s=n}return e.slice(0,s)},basename(e,t){void 0!==t&&r(t,"ext"),r(e,"path");let n,s=0,a=-1,u=!0;if(e.length>=2){o(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(s=2)}if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";let r=t.length-1,o=-1;for(n=e.length-1;n>=s;--n){const l=e.charCodeAt(n);if(i(l)){if(!u){s=n+1;break}}else-1===o&&(u=!1,o=n+1),r>=0&&(l===t.charCodeAt(r)?-1==--r&&(a=n):(r=-1,a=o))}return s===a?a=o:-1===a&&(a=e.length),e.slice(s,a)}for(n=e.length-1;n>=s;--n)if(i(e.charCodeAt(n))){if(!u){s=n+1;break}}else-1===a&&(u=!1,a=n+1);return-1===a?"":e.slice(s,a)},extname(e){r(e,"path");let t=0,n=-1,s=0,a=-1,u=!0,l=0;e.length>=2&&58===e.charCodeAt(1)&&o(e.charCodeAt(0))&&(t=s=2);for(let r=e.length-1;r>=t;--r){const t=e.charCodeAt(r);if(i(t)){if(!u){s=r+1;break}
}else-1===a&&(u=!1,a=r+1),t===f?-1===n?n=r:1!==l&&(l=1):-1!==n&&(l=-1)}return-1===n||-1===a||0===l||1===l&&n===a-1&&n===s+1?"":e.slice(n,a)},format(e){if(null===e||"object"!=typeof e)throw new g("pathObject","Object",e);return u("\\",e)},parse(e){r(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.length;let s=0,a=e.charCodeAt(0);if(n>1){if(i(a)){if(s=1,i(e.charCodeAt(1))){let t=2,r=t;for(;t<n&&!i(e.charCodeAt(t));++t);if(t<n&&t!==r){for(r=t;t<n&&i(e.charCodeAt(t));++t);if(t<n&&t!==r){for(r=t;t<n&&!i(e.charCodeAt(t));++t);t===n?s=t:t!==r&&(s=t+1)}}}}else if(o(a)&&58===e.charCodeAt(1)){if(s=2,!(n>2))return t.root=t.dir=e,t;if(i(e.charCodeAt(2))){if(3===n)return t.root=t.dir=e,t;s=3}}}else if(i(a))return t.root=t.dir=e,t;s>0&&(t.root=e.slice(0,s));let u=-1,l=s,c=-1,h=!0,d=e.length-1,p=0;for(;d>=s;--d)if(a=e.charCodeAt(d),i(a)){if(!h){l=d+1;break}}else-1===c&&(h=!1,c=d+1),a===f?-1===u?u=d:1!==p&&(p=1):-1!==u&&(p=-1)
;return-1===u||-1===c||0===p||1===p&&u===c-1&&u===l+1?-1!==c&&(t.base=t.name=e.slice(l,c)):(t.name=e.slice(l,u),t.base=e.slice(l,c),t.ext=e.slice(u,c)),t.dir=l>0&&l!==s?e.slice(0,l-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){let t="",i=!1;for(let s=e.length-1;s>=-1&&!i;s--){let o;r(o=s>=0?e[s]:n.cwd(),"path"),0!==o.length&&(t=o+"/"+t,i=o.charCodeAt(0)===p)}return t=a(t,!i,"/",s),i?t.length>0?"/"+t:"/":t.length>0?t:"."},normalize(e){if(r(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===p,n=e.charCodeAt(e.length-1)===p;return 0!==(e=a(e,!t,"/",s)).length||t||(e="."),e.length>0&&n&&(e+="/"),t?"/"+e:e},isAbsolute:e=>(r(e,"path"),e.length>0&&e.charCodeAt(0)===p),join(...e){if(0===e.length)return".";let n;for(let t=0;t<e.length;++t){const e=arguments[t];r(e,"path"),e.length>0&&(void 0===n?n=e:n+="/"+e)}return void 0===n?".":t.posix.normalize(n)},relative(e,n){if(r(e,"from"),r(n,"to"),e===n)return"";if(e=t.posix.resolve(e),n=t.posix.resolve(n),e===n)return"";let i=1
;for(;i<e.length&&e.charCodeAt(i)===p;++i);const s=e.length,o=s-i;let a=1;for(;a<n.length&&n.charCodeAt(a)===p;++a);const u=n.length-a,l=o<u?o:u;let c=-1,h=0;for(;h<=l;++h){if(h===l){if(u>l){if(n.charCodeAt(a+h)===p)return n.slice(a+h+1);if(0===h)return n.slice(a+h)}else o>l&&(e.charCodeAt(i+h)===p?c=h:0===h&&(c=0));break}const t=e.charCodeAt(i+h);if(t!==n.charCodeAt(a+h))break;t===p&&(c=h)}let d="";for(h=i+c+1;h<=s;++h)h!==s&&e.charCodeAt(h)!==p||(0===d.length?d+="..":d+="/..");return d.length>0?d+n.slice(a+c):(a+=c,n.charCodeAt(a)===p&&++a,n.slice(a))},toNamespacedPath:e=>e,dirname(e){if(r(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===p;let n=-1,i=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===p){if(!i){n=t;break}}else i=!1;return-1===n?t?"/":".":t&&1===n?"//":e.slice(0,n)},basename(e,t){void 0!==t&&r(t,"ext"),r(e,"path");let n,i=0,s=-1,o=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";let r=t.length-1,a=-1;for(n=e.length-1;n>=0;--n){
const u=e.charCodeAt(n);if(u===p){if(!o){i=n+1;break}}else-1===a&&(o=!1,a=n+1),r>=0&&(u===t.charCodeAt(r)?-1==--r&&(s=n):(r=-1,s=a))}return i===s?s=a:-1===s&&(s=e.length),e.slice(i,s)}for(n=e.length-1;n>=0;--n)if(e.charCodeAt(n)===p){if(!o){i=n+1;break}}else-1===s&&(o=!1,s=n+1);return-1===s?"":e.slice(i,s)},extname(e){r(e,"path");let t=-1,n=0,i=-1,s=!0,o=0;for(let r=e.length-1;r>=0;--r){const a=e.charCodeAt(r);if(a!==p)-1===i&&(s=!1,i=r+1),a===f?-1===t?t=r:1!==o&&(o=1):-1!==t&&(o=-1);else if(!s){n=r+1;break}}return-1===t||-1===i||0===o||1===o&&t===i-1&&t===n+1?"":e.slice(t,i)},format(e){if(null===e||"object"!=typeof e)throw new g("pathObject","Object",e);return u("/",e)},parse(e){r(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.charCodeAt(0)===p;let i;n?(t.root="/",i=1):i=0;let s=-1,o=0,a=-1,u=!0,l=e.length-1,c=0;for(;l>=i;--l){const t=e.charCodeAt(l);if(t!==p)-1===a&&(u=!1,a=l+1),t===f?-1===s?s=l:1!==c&&(c=1):-1!==s&&(c=-1);else if(!u){o=l+1;break}}
return-1===s||-1===a||0===c||1===c&&s===a-1&&s===o+1?-1!==a&&(t.base=t.name=0===o&&n?e.slice(1,a):e.slice(o,a)):(0===o&&n?(t.name=e.slice(1,s),t.base=e.slice(1,a)):(t.name=e.slice(o,s),t.base=e.slice(o,a)),t.ext=e.slice(s,a)),o>0?t.dir=e.slice(0,o-1):n&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===n.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===n.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===n.platform?t.win32.join:t.posix.join,t.resolve="win32"===n.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===n.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===n.platform?t.win32.dirname:t.posix.dirname,t.basename="win32"===n.platform?t.win32.basename:t.posix.basename,t.extname="win32"===n.platform?t.win32.extname:t.posix.extname,t.format="win32"===n.platform?t.win32.format:t.posix.format,t.parse="win32"===n.platform?t.win32.parse:t.posix.parse,
t.toNamespacedPath="win32"===n.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===n.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===n.platform?t.win32.delimiter:t.posix.delimiter}),i(e[3],t([1,0]),function(e,t){"use strict";function n(e){return e.replace(/[\-\\\{\}\*\+\?\|\^\$\.\[\]\(\)\#]/g,"\\$&")}function r(e,t){if(!e||!t)return e;const n=t.length;if(0===n||0===e.length)return e;let r=0;for(;e.indexOf(t,r)===r;)r+=n;return e.substring(r)}function i(e,t){if(!e||!t)return e;const n=t.length,r=e.length;if(0===n||0===r)return e;let i=r,s=-1;for(;;){if(-1===(s=e.lastIndexOf(t,i-1))||s+n!==i)break;if(0===s)return"";i=s}return e.substring(0,i)}function s(e,t){return e<t?-1:e>t?1:0}function o(e){return e>=97&&e<=122}function a(e){return e>=65&&e<=90}function u(e){return o(e)||a(e)}function l(e,t,n=e.length){if("string"!=typeof e||"string"!=typeof t)return!1;for(let r=0;r<n;r++){const n=e.charCodeAt(r),i=t.charCodeAt(r);if(n!==i)if(u(n)&&u(i)){const e=Math.abs(n-i)
;if(0!==e&&32!==e)return!1}else if(String.fromCharCode(n).toLowerCase()!==String.fromCharCode(i).toLowerCase())return!1}return!0}function c(e,t,n,r,i,s){for(;t<n&&i<s;){if(e[t]!==r[i])return!1;t+=1,i+=1}return!0}function h(e){return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}function d(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}Object.defineProperty(t,"__esModule",{value:!0}),t.empty="",t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length},t.pad=function(e,t,n="0"){const r=""+e,i=[r];for(let e=r.length;e<t;e++)i.push(n);return i.reverse().join("")};const f=/{(\d+)}/g;t.format=function(e,...t){return 0===t.length?e:e.replace(f,function(e,n){const r=parseInt(n,10);return isNaN(r)||r<0||r>=t.length?e:t[r]})},t.escape=function(e){return e.replace(/[<>&]/g,function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}})},t.escapeRegExpCharacters=n,t.trim=function(e,t=" "){return i(r(e,t),t)},t.ltrim=r,t.rtrim=i,
t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.startsWith=function(e,t){if(e.length<t.length)return!1;if(e===t)return!0;for(let n=0;n<t.length;n++)if(e[n]!==t[n])return!1;return!0},t.endsWith=function(e,t){const n=e.length-t.length;return n>0?e.indexOf(t,n)===n:0===n&&e===t},t.createRegExp=function(e,t,r={}){if(!e)throw new Error("Cannot create regex from empty string");t||(e=n(e)),r.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let i="";return r.global&&(i+="g"),r.matchCase||(i+="i"),r.multiline&&(i+="m"),r.unicode&&(i+="u"),new RegExp(e,i)},t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){
return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(let t=0,n=e.length;t<n;t++){const n=e.charCodeAt(t);if(32!==n&&9!==n)return t}return-1},t.getLeadingWhitespace=function(e,t=0,n=e.length){for(let r=t;r<n;r++){const n=e.charCodeAt(r);if(32!==n&&9!==n)return e.substring(t,r)}return e.substring(t,n)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){for(let n=t;n>=0;n--){const t=e.charCodeAt(n);if(32!==t&&9!==t)return n}return-1},t.compare=s,t.compareIgnoreCase=function(e,t){const n=Math.min(e.length,t.length);for(let r=0;r<n;r++){let n=e.charCodeAt(r),i=t.charCodeAt(r);if(n===i)continue;a(n)&&(n+=32),a(i)&&(i+=32);const u=n-i;if(0!==u)return o(n)&&o(i)?u:s(e.toLowerCase(),t.toLowerCase())}return e.length<t.length?-1:e.length>t.length?1:0},t.isLowerAsciiLetter=o,t.isUpperAsciiLetter=a,t.equalsIgnoreCase=function(e,t){return(e?e.length:0)===(t?t.length:0)&&l(e,t)},t.startsWithIgnoreCase=function(e,t){const n=t.length
;return!(t.length>e.length)&&l(e,t,n)},t.commonPrefixLength=function(e,t){let n,r=Math.min(e.length,t.length);for(n=0;n<r;n++)if(e.charCodeAt(n)!==t.charCodeAt(n))return n;return r},t.commonSuffixLength=function(e,t){let n,r=Math.min(e.length,t.length);const i=e.length-1,s=t.length-1;for(n=0;n<r;n++)if(e.charCodeAt(i-n)!==t.charCodeAt(s-n))return n;return r},t.overlap=function(e,t){const n=e.length;let r=t.length,i=n-r;if(0===i)return e===t?n:0;for(i<0&&(r+=i,i=0);i<n&&r>0;){if(c(e,i,n,t,0,r))return r;r-=1,i+=1}return 0},t.isHighSurrogate=function(e){return 55296<=e&&e<=56319},t.isLowSurrogate=function(e){return 56320<=e&&e<=57343}
;const p=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;t.containsRTL=function(e){return p.test(e)};const m=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEF8]|\uD83E[\uDD00-\uDDE6])/;t.containsEmoji=function(e){return m.test(e)};const g=/^[\t\n\r\x20-\x7E]*$/;t.isBasicASCII=function(e){return g.test(e)},t.containsFullWidthCharacter=function(e){for(let t=0,n=e.length;t<n;t++)if(h(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=h,t.lcut=function(e,n){if(e.length<n)return e;const r=/\b/g
;let i=0;for(;r.test(e)&&!(e.length-r.lastIndex<n);)i=r.lastIndex,r.lastIndex+=1;return e.substring(i).replace(/^\s/,t.empty)};const _=/\x1B\x5B[12]?K/g,v=/\x1b\[\d+m/g,y=/\x1b\[0?m/g;t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(_,"")).replace(v,"")).replace(y,"")),e},t.removeAccents=function(){if("function"!=typeof String.prototype.normalize)return function(e){return e};{const e=/[\u0300-\u036f]/g;return function(n){return n.normalize("NFD").replace(e,t.empty)}}}(),t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=d,t.stripUTF8BOM=function(e){return d(e)?e.substr(1):e},t.safeBtoa=function(e){return btoa(encodeURIComponent(e))},t.repeat=function(e,t){let n="";for(let r=0;r<t;r++)n+=e;return n},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;const n=t.length,r=e.toLowerCase();let i=0,s=-1;for(;i<n;){const e=r.indexOf(t[i],s+1);if(e<0)return!1;s=e,i++}return!0},t.containsUppercaseCharacter=function(e,t=!1){
return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t=1){if(0===t)return"";let n=-1;do{n=e.indexOf("\n",n+1),t--}while(t>0&&n>=0);return n>=0?e.substr(0,n):e}}),i(e[12],t([1,0,2,3,4]),function(e,t,n,r,i){"use strict";function s(e){return 47===e||92===e}function o(e){return e>=65&&e<=90||e>=97&&e<=122}Object.defineProperty(t,"__esModule",{value:!0}),t.toSlashes=function(e){return e.replace(/[\\/]/g,i.posix.sep)},t.getRoot=function(e,t=i.posix.sep){if(!e)return"";const n=e.length,r=e.charCodeAt(0);if(s(r)){if(s(e.charCodeAt(1))&&!s(e.charCodeAt(2))){let r=3;const i=r;for(;r<n&&!s(e.charCodeAt(r));r++);if(i!==r&&!s(e.charCodeAt(r+1)))for(r+=1;r<n;r++)if(s(e.charCodeAt(r)))return e.slice(0,r+1).replace(/[\\/]/g,t)}return t}if(o(r)&&58===e.charCodeAt(1))return s(e.charCodeAt(2))?e.slice(0,2)+t:e.slice(0,2);let a=e.indexOf("://");if(-1!==a)for(a+=3;a<n;a++)if(s(e.charCodeAt(a)))return e.slice(0,a+1)
;return""},t.isUNC=function(e){if(!n.isWindows)return!1;if(!e||e.length<5)return!1;let t=e.charCodeAt(0);if(92!==t)return!1;if(92!==(t=e.charCodeAt(1)))return!1;let r=2;const i=r;for(;r<e.length&&92!==(t=e.charCodeAt(r));r++);return i!==r&&(t=e.charCodeAt(r+1),!isNaN(t)&&92!==t)};const a=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])$/i;t.isValidBasename=function(e,t=n.isWindows){const r=t?a:u;return!(!e||0===e.length||/^\s+$/.test(e)||(r.lastIndex=0,r.test(e)||t&&l.test(e)||"."===e||".."===e||t&&"."===e[e.length-1]||t&&e.length!==e.trim().length||e.length>255))},t.isEqual=function(e,t,n){const i=e===t;return!n||i?i:!(!e||!t)&&r.equalsIgnoreCase(e,t)},t.isEqualOrParent=function(e,t,n,s=i.sep){if(e===t)return!0;if(!e||!t)return!1;if(t.length>e.length)return!1;if(n){if(!r.startsWithIgnoreCase(e,t))return!1;if(t.length===e.length)return!0;let n=t.length;return t.charAt(t.length-1)===s&&n--,e.charAt(n)===s}return t.charAt(t.length-1)!==s&&(t+=s),0===e.indexOf(t)},
t.isWindowsDriveLetter=o,t.sanitizeFilePath=function(e,t){return n.isWindows&&r.endsWith(e,":")&&(e+=i.sep),i.isAbsolute(e)||(e=i.join(t,e)),e=i.normalize(e),n.isWindows?(e=r.rtrim(e,i.sep),r.endsWith(e,":")&&(e+=i.sep)):(e=r.rtrim(e,i.sep))||(e=i.sep),e},t.isRootOrDriveLetter=function(e){const t=i.normalize(e);return n.isWindows?!(e.length>3)&&o(t.charCodeAt(0))&&58===t.charCodeAt(1)&&(2===e.length||92===t.charCodeAt(2)):t===i.posix.sep}}),i(e[5],t([1,0,2]),function(e,t,n){"use strict";function r(e,t){let n=void 0,r=-1;for(let i=0;i<e.length;i++){const s=e.charCodeAt(i);if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||45===s||46===s||95===s||126===s||t&&47===s)-1!==r&&(n+=encodeURIComponent(e.substring(r,i)),r=-1),void 0!==n&&(n+=e.charAt(i));else{void 0===n&&(n=e.substr(0,i));const t=g[s];void 0!==t?(-1!==r&&(n+=encodeURIComponent(e.substring(r,i)),r=-1),n+=t):-1===r&&(r=i)}}return-1!==r&&(n+=encodeURIComponent(e.substring(r))),void 0!==n?n:e}function i(e){let t
;return t=e.authority&&e.path.length>1&&"file"===e.scheme?`//${e.authority}${e.path}`:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?e.path[1].toLowerCase()+e.path.substr(2):e.path,n.isWindows&&(t=t.replace(/\//g,"\\")),t}function s(e,t){const n=t?function(e){let t=void 0;for(let n=0;n<e.length;n++){const r=e.charCodeAt(n);35===r||63===r?(void 0===t&&(t=e.substr(0,n)),t+=g[r]):void 0!==t&&(t+=e[n])}return void 0!==t?t:e}:r;let i="",{scheme:s,authority:o,path:a,query:u,fragment:l}=e;if(s&&(i+=s,i+=":"),(o||"file"===s)&&(i+=h,i+=h),o){let e=o.indexOf("@");if(-1!==e){const t=o.substr(0,e);o=o.substr(e+1),-1===(e=t.indexOf(":"))?i+=n(t,!1):(i+=n(t.substr(0,e),!1),i+=":",i+=n(t.substr(e+1),!1)),i+="@"}-1===(e=(o=o.toLowerCase()).indexOf(":"))?i+=n(o,!1):(i+=n(o.substr(0,e),!1),i+=o.substr(e))}if(a){if(a.length>=3&&47===a.charCodeAt(0)&&58===a.charCodeAt(2)){const e=a.charCodeAt(1)
;e>=65&&e<=90&&(a=`/${String.fromCharCode(e+32)}:${a.substr(3)}`)}else if(a.length>=2&&58===a.charCodeAt(1)){const e=a.charCodeAt(0);e>=65&&e<=90&&(a=`${String.fromCharCode(e+32)}:${a.substr(2)}`)}i+=n(a,!0)}return u&&(i+="?",i+=n(u,!1)),l&&(i+="#",i+=t?l:r(l,!1)),i}Object.defineProperty(t,"__esModule",{value:!0});const o=/^\w[\w\d+.-]*$/,a=/^\//,u=/^\/\//;let l=!0;t.setUriThrowOnMissingScheme=function(e){const t=l;return l=e,t};const c="",h="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(e){return e instanceof f||!!e&&("string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString)}constructor(e,t,n,r,i,s=!1){"object"==typeof e?(this.scheme=e.scheme||c,this.authority=e.authority||c,this.path=e.path||c,this.query=e.query||c,this.fragment=e.fragment||c):(this.scheme=function(e,t){
return t||l?e||c:(e||(console.trace("BAD uri lacks scheme, falling back to file-scheme."),e="file"),e)}(e,s),this.authority=t||c,this.path=function(e,t){switch(e){case"https":case"http":case"file":t?t[0]!==h&&(t=h+t):t=h}return t}(this.scheme,n||c),this.query=r||c,this.fragment=i||c,function(e,t){if(!e.scheme){if(t||l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`);console.warn(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`)}if(e.scheme&&!o.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!a.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')
}else if(u.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,s))}get fsPath(){return i(this)}with(e){if(!e)return this;let{scheme:t,authority:n,path:r,query:i,fragment:s}=e;return void 0===t?t=this.scheme:null===t&&(t=c),void 0===n?n=this.authority:null===n&&(n=c),void 0===r?r=this.path:null===r&&(r=c),void 0===i?i=this.query:null===i&&(i=c),void 0===s?s=this.fragment:null===s&&(s=c),t===this.scheme&&n===this.authority&&r===this.path&&i===this.query&&s===this.fragment?this:new m(t,n,r,i,s)}static parse(e,t=!1){const n=d.exec(e);return n?new m(n[2]||c,decodeURIComponent(n[4]||c),decodeURIComponent(n[5]||c),decodeURIComponent(n[7]||c),decodeURIComponent(n[9]||c),t):new m(c,c,c,c,c)}static file(e){let t=c;if(n.isWindows&&(e=e.replace(/\\/g,h)),e[0]===h&&e[1]===h){const n=e.indexOf(h,2);-1===n?(t=e.substring(2),e=h):(t=e.substring(2,n),e=e.substring(n)||h)}return new m("file",t,e,c,c)}static from(e){
return new m(e.scheme,e.authority,e.path,e.query,e.fragment)}toString(e=!1){return s(this,e)}toJSON(){return this}static revive(e){if(e){if(e instanceof f)return e;{const t=new m(e);return t._formatted=e.external,t._fsPath=e._sep===p?e.fsPath:null,t}}return e}}t.URI=f;const p=n.isWindows?1:void 0;class m extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this)),this._fsPath}toString(e=!1){return e?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const e={$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=p),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e}}const g={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",
44:"%2C",59:"%3B",61:"%3D",32:"%20"}}),i(e[14],t([1,0,5,10]),function(e,t,n,r){"use strict";function i(e){const t=[];return e.forEach(e=>t.push(e)),t}function s(e){const t=[];return e.forEach((e,n)=>t.push(n)),t}Object.defineProperty(t,"__esModule",{value:!0}),t.values=i,t.keys=s,t.getOrSet=function(e,t,n){let r=e.get(t);return void 0===r&&(r=n,e.set(t,r)),r},t.mapToString=function(e){const t=[];return e.forEach((e,n)=>{t.push(`${n} => ${e}`)}),`Map(${e.size}) {${t.join(", ")}}`},t.setToString=function(e){const t=[];return e.forEach(e=>{t.push(e)}),`Set(${e.size}) {${t.join(", ")}}`},t.mapToSerializable=function(e){const t=[];return e.forEach((e,n)=>{t.push([n,e])}),t},t.serializableToMap=function(e){const t=new Map;for(const[n,r]of e)t.set(n,r);return t};class o{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){return e.charCodeAt(0)-this._value.charCodeAt(this._pos)}value(){
return this._value[this._pos]}}t.StringIterator=o;class a{reset(e){return this._value=e.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(47===t||92===t){if(!e)break;this._from++}else e=!1}return this}cmp(e){let t=0;const n=e.length;let r=this._from;for(;t<n&&r<this._to;){const n=e.charCodeAt(t)-this._value.charCodeAt(r);if(0!==n)return n;t+=1,r+=1}return n===this._to-this._from?0:t<n?-1:1}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=a;class u{isEmpty(){return!(this.left||this.mid||this.right||this.value)}}class l{constructor(e){this._iter=e}static forPaths(){return new l(new a)}static forStrings(){return new l(new o)}clear(){this._root=void 0}set(e,t){const n=this._iter.reset(e);let r;for(this._root||(this._root=new u,this._root.segment=n.value()),r=this._root;;){const e=n.cmp(r.segment)
;if(e>0)r.left||(r.left=new u,r.left.segment=n.value()),r=r.left;else if(e<0)r.right||(r.right=new u,r.right.segment=n.value()),r=r.right;else{if(!n.hasNext())break;n.next(),r.mid||(r.mid=new u,r.mid.segment=n.value()),r=r.mid}}const i=r.value;return r.value=t,r.key=e,i}get(e){const t=this._iter.reset(e);let n=this._root;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{if(!t.hasNext())break;t.next(),n=n.mid}}return n?n.value:void 0}delete(e){const t=this._iter.reset(e),n=[];let r=this._root;for(;r;){const e=t.cmp(r.segment);if(e>0)n.push([1,r]),r=r.left;else if(e<0)n.push([-1,r]),r=r.right;else{if(!t.hasNext()){for(r.value=void 0;n.length>0&&r.isEmpty();){let[e,t]=n.pop();switch(e){case 1:t.left=void 0;break;case 0:t.mid=void 0;break;case-1:t.right=void 0}r=t}break}t.next(),n.push([0,r]),r=r.mid}}}findSubstr(e){const t=this._iter.reset(e);let n=this._root,r=void 0;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{if(!t.hasNext())break;t.next(),
r=n.value||r,n=n.mid}}return n&&n.value||r}findSuperstr(e){const t=this._iter.reset(e);let n=this._root;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{if(!t.hasNext())return n.mid?this._nodeIterator(n.mid):void 0;t.next(),n=n.mid}}}_nodeIterator(e){let t,n,i;return{next:()=>(i||(i=[],n=0,this._forEach(e,e=>i.push(e))),n>=i.length?r.FIN:(t?t.value=i[n++]:t={done:!1,value:i[n++]},t))}}forEach(e){this._forEach(this._root,e)}_forEach(e,t){e&&(this._forEach(e.left,t),e.value&&t(e.value,e.key),this._forEach(e.mid,t),this._forEach(e.right,t))}}t.TernarySearchTree=l;class c{constructor(){this.map=new Map,this.ignoreCase=!1}set(e,t){this.map.set(this.toKey(e),t)}get(e){return this.map.get(this.toKey(e))}has(e){return this.map.has(this.toKey(e))}get size(){return this.map.size}clear(){this.map.clear()}delete(e){return this.map.delete(this.toKey(e))}forEach(e){this.map.forEach(e)}values(){return i(this.map)}toKey(e){let t=e.toString();return this.ignoreCase&&(t=t.toLowerCase()),t}keys(){
return s(this.map).map(e=>n.URI.parse(e))}clone(){const e=new c;return this.map.forEach((t,n)=>e.map.set(n,t)),e}}t.ResourceMap=c;!function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"}(t.Touch||(t.Touch={}));class h{constructor(){this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}has(e){return this._map.has(e)}get(e,t=0){const n=this._map.get(e);if(n)return 0!==t&&this.touch(n,t),n.value}set(e,t,n=0){let r=this._map.get(e);if(r)r.value=t,0!==n&&this.touch(r,n);else{switch(r={key:e,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:default:this.addItemLast(r)}this._map.set(e,r),this._size++}}delete(e){return!!this.remove(e)}remove(e){const t=this._map.get(e);if(t)return this._map.delete(e),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return
;if(!this._head||!this._tail)throw new Error("Invalid list");const e=this._head;return this._map.delete(e.key),this.removeItem(e),this._size--,e.value}forEach(e,t){let n=this._head;for(;n;)t?e.bind(t)(n.value,n.key,this):e(n.value,n.key,this),n=n.next}values(){const e=[];let t=this._head;for(;t;)e.push(t.value),t=t.next;return e}keys(){const e=[];let t=this._head;for(;t;)e.push(t.key),t=t.next;return e}trimOld(e){if(e>=this.size)return;if(0===e)return void this.clear();let t=this._head,n=this.size;for(;t&&n>e;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0)}addItemFirst(e){if(this._head||this._tail){if(!this._head)throw new Error("Invalid list");e.next=this._head,this._head.previous=e}else this._tail=e;this._head=e}addItemLast(e){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");e.previous=this._tail,this._tail.next=e}else this._head=e;this._tail=e}removeItem(e){if(e===this._head&&e===this._tail)this._head=void 0,
this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next}else if(e===this._tail){if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous}else{const t=e.next,n=e.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}e.next=void 0,e.previous=void 0}touch(e,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===t||2===t)if(1===t){if(e===this._head)return;const t=e.next,n=e.previous;e===this._tail?(n.next=void 0,this._tail=n):(t.previous=n,n.next=t),e.previous=void 0,e.next=this._head,this._head.previous=e,this._head=e}else if(2===t){if(e===this._tail)return;const t=e.next,n=e.previous;e===this._head?(t.previous=void 0,this._head=t):(t.previous=n,n.next=t),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e}}toJSON(){const e=[];return this.forEach((t,n)=>{e.push([n,t])}),e}fromJSON(e){this.clear();for(const[t,n]of e)this.set(t,n)}}t.LinkedMap=h
;class d extends h{constructor(e,t=1){super(),this._limit=e,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(e){this._limit=e,this.checkTrim()}get ratio(){return this._ratio}set ratio(e){this._ratio=Math.min(Math.max(0,e),1),this.checkTrim()}get(e){return super.get(e,2)}peek(e){return super.get(e,0)}set(e,t){super.set(e,t,2),this.checkTrim()}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=d}),i(e[15],t([1,0,13,3,12,4,14,18]),function(e,t,n,r,i,s,o,a){"use strict";function u(e){switch(e){case 0:return"";case 1:return`${x}*?`;default:return`(?:${w}|${x}+${w}|${w}${x}+)*?`}}function l(e,t){if(!e)return[];const n=[];let r=!1,i=!1,s="";for(const o of e){switch(o){case t:if(!r&&!i){n.push(s),s="";continue}break;case"{":r=!0;break;case"}":r=!1;break;case"[":i=!0;break;case"]":i=!1}s+=o}return s&&n.push(s),n}function c(e){if(!e)return"";let t="";const n=l(e,b);if(n.every(e=>e===y))t=".*";else{let e=!1;n.forEach((i,s)=>{
if(i===y)return void(e||(t+=u(2),e=!0));let o=!1,a="",h=!1,d="";for(const e of i)if("}"!==e&&o)a+=e;else if(!h||"]"===e&&d)switch(e){case"{":o=!0;continue;case"[":h=!0;continue;case"}":const n=`(?:${l(a,",").map(e=>c(e)).join("|")})`;t+=n,o=!1,a="";break;case"]":t+="["+d+"]",h=!1,d="";break;case"?":t+=x;continue;case"*":t+=u(1);continue;default:t+=r.escapeRegExpCharacters(e)}else{let t;d+=t="-"===e?e:"^"!==e&&"!"!==e||d?e===b?"":r.escapeRegExpCharacters(e):"^"}s<n.length-1&&(n[s+1]!==y||s+2<n.length)&&(t+=w),e=!1})}return t}function h(e,t){if(!e)return O;let i;i="string"!=typeof e?e.pattern:e;const s=`${i=i.trim()}_${!!t.trimForExclusions}`;let o=k.get(s);if(o)return d(o,e);let a;if(E.test(i)){const e=i.substr(4);o=function(t,n){return"string"==typeof t&&r.endsWith(t,e)?i:null}}else o=(a=A.exec(f(i,t)))?function(e,t){const n=`/${e}`,i=`\\${e}`,s=function(s,o){return"string"!=typeof s?null:o?o===e?t:null:s===e||r.endsWith(s,n)||r.endsWith(s,i)?t:null},o=[e];return s.basenames=o,s.patterns=[t],s.allBasenames=o,
s}(a[1],i):(t.trimForExclusions?I:M).test(i)?function(e,t){const r=v(e.slice(1,-1).split(",").map(e=>h(e,t)).filter(e=>e!==O),e),i=r.length;if(!i)return O;if(1===i)return r[0];const s=function(t,n){for(let i=0,s=r.length;i<s;i++)if(r[i](t,n))return e;return null},o=n.first(r,e=>!!e.allBasenames);o&&(s.allBasenames=o.allBasenames);const a=r.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);a.length&&(s.allPaths=a);return s}(i,t):(a=P.exec(f(i,t)))?p(a[1].substr(1),i,!0):(a=D.exec(f(i,t)))?p(a[1],i,!1):function(e){try{const t=new RegExp(`^${c(e)}$`);return function(n,r){return t.lastIndex=0,"string"==typeof n&&t.test(n)?e:null}}catch(e){return O}}(i);return k.set(s,o),d(o,e)}function d(e,t){return"string"==typeof t?e:function(n,r){return i.isEqualOrParent(n,t.base)?e(s.relative(t.base,n),r):null}}function f(e,t){return t.trimForExclusions&&r.endsWith(e,"/**")?e.substr(0,e.length-2):e}function p(e,t,n){const i=s.sep!==s.posix.sep?e.replace(C,s.sep):e,o=s.sep+i,a=n?function(e,n){
return"string"!=typeof e||e!==i&&!r.endsWith(e,o)?null:t}:function(e,n){return"string"==typeof e&&e===i?t:null};return a.allPaths=[(n?"*/":"./")+e],a}function m(e,t={}){if(!e)return R;if("string"==typeof e||_(e)){const n=h(e,t);if(n===O)return R;const r=function(e,t){return!!n(e,t)};return n.allBasenames&&(r.allBasenames=n.allBasenames),n.allPaths&&(r.allPaths=n.allPaths),r}return function(e,t){const r=v(Object.getOwnPropertyNames(e).map(n=>(function(e,t,n){if(!1===t)return O;const r=h(e,n);if(r===O)return O;if("boolean"==typeof t)return r;if(t){const n=t.when;if("string"==typeof n){const t=(t,i,s,o)=>{if(!o||!r(t,i))return null;const u=n.replace("$(basename)",s),l=o(u);return a.isThenable(l)?l.then(t=>t?e:null):l?e:null};return t.requiresSiblings=!0,t}}return r})(n,e[n],t)).filter(e=>e!==O)),i=r.length;if(!i)return O;if(!r.some(e=>!!e.requiresSiblings)){if(1===i)return r[0];const e=function(e,t){for(let n=0,i=r.length;n<i;n++){const i=r[n](e,t);if(i)return i}return null},t=n.first(r,e=>!!e.allBasenames)
;t&&(e.allBasenames=t.allBasenames);const s=r.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);return s.length&&(e.allPaths=s),e}const o=function(e,t,n){let i=void 0;for(let o=0,a=r.length;o<a;o++){const a=r[o];a.requiresSiblings&&n&&(t||(t=s.basename(e)),i||(i=t.substr(0,t.length-s.extname(e).length)));const u=a(e,t,i,n);if(u)return u}return null},u=n.first(r,e=>!!e.allBasenames);u&&(o.allBasenames=u.allBasenames);const l=r.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);l.length&&(o.allPaths=l);return o}(e,t)}function g(e){const t={};for(const n of e)t[n]=!0;return t}function _(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}function v(e,t){const n=e.filter(e=>!!e.basenames);if(n.length<2)return e;const r=n.reduce((e,t)=>{const n=t.basenames;return n?e.concat(n):e},[]);let i;if(t){i=[];for(let e=0,n=r.length;e<n;e++)i.push(t)}else i=n.reduce((e,t)=>{const n=t.patterns;return n?e.concat(n):e},[]);const s=function(e,t){if("string"!=typeof e)return null;if(!t){let n
;for(n=e.length;n>0;n--){const t=e.charCodeAt(n-1);if(47===t||92===t)break}t=e.substr(n)}const n=r.indexOf(t);return-1!==n?i[n]:null};s.basenames=r,s.patterns=i,s.allBasenames=r;const o=e.filter(e=>!e.basenames);return o.push(s),o}Object.defineProperty(t,"__esModule",{value:!0}),t.getEmptyExpression=function(){return Object.create(null)};const y="**",b="/",w="[/\\\\]",x="[^/\\\\]",C=/\//g;t.splitGlobAware=l;const E=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,M=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,I=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,k=new o.LRUCache(1e4),R=function(){return!1},O=function(){return null};t.match=function(e,t,n){return!(!e||"string"!=typeof t)&&m(e)(t,void 0,n)},t.parse=m,t.hasSiblingPromiseFn=function(e){if(!e)return;let t;return n=>(t||(t=(e()||Promise.resolve([])).then(e=>e?g(e):{})),t.then(e=>!!e[n]))},t.hasSiblingFn=function(e){if(!e)return;let t;return n=>{
if(!t){const n=e();t=n?g(n):{}}return!!t[n]}},t.isRelativePattern=_,t.getBasenameTerms=function(e){return e.allBasenames||[]},t.getPathTerms=function(e){return e.allPaths||[]}}),i(e[20],t([1,0,12,4,5,3,8,2,15,14]),function(e,t,n,r,i,s,o,a,u,l){"use strict";function c(e){return!e||e.scheme!==o.Schemas.file||!a.isLinux}function h(e,t,r=c(e)){if(e.scheme===t.scheme){if(e.scheme===o.Schemas.file)return n.isEqualOrParent(p(e),p(t),r);if(d(e.authority,t.authority))return n.isEqualOrParent(e.path,t.path,r,"/")}return!1}function d(e,t){return e===t||s.equalsIgnoreCase(e,t)}function f(e){return r.posix.basename(e.path)}function p(e){let t;const r=e.path;return t=e.authority&&r.length>1&&e.scheme===o.Schemas.file?`//${e.authority}${r}`:a.isWindows&&47===r.charCodeAt(0)&&n.isWindowsDriveLetter(r.charCodeAt(1))&&58===r.charCodeAt(2)?r.substr(1):r,a.isWindows&&(t=t.replace(/\//g,"\\")),t}function m(e,t=r.sep){if(e.scheme===o.Schemas.file){const r=p(e);return r.length>n.getRoot(r).length&&r[r.length-1]===t}{const t=e.path
;return t.length>1&&47===t.charCodeAt(t.length-1)}}function g(e,t,i=c(e)){if(e.scheme!==t.scheme||!d(e.authority,t.authority))return;if(e.scheme===o.Schemas.file){const i=r.relative(e.path,t.path);return a.isWindows?n.toSlashes(i):i}let s=e.path||"/",u=t.path||"/";if(i){let e=0;for(const t=Math.min(s.length,u.length);e<t&&(s.charCodeAt(e)===u.charCodeAt(e)||s.charAt(e).toLowerCase()===u.charAt(e).toLowerCase());e++);s=u.substr(0,e)+s.substr(e)}return r.posix.relative(s,u)}Object.defineProperty(t,"__esModule",{value:!0}),t.getComparisonKey=function(e){return c(e)?e.toString().toLowerCase():e.toString()},t.hasToIgnoreCase=c,t.basenameOrAuthority=function(e){return f(e)||e.authority},t.isEqualOrParent=h,t.isEqualAuthority=d,t.isEqual=function(e,t,n=c(e)){if(e===t)return!0;if(!e||!t)return!1;if(e.scheme!==t.scheme||!d(e.authority,t.authority))return!1;const r=e.path||"/",i=t.path||"/";return r===i||n&&s.equalsIgnoreCase(r||"/",i||"/")},t.basename=f,t.extname=function(e){return r.posix.extname(e.path)},
t.dirname=function(e){if(0===e.path.length)return e;if(e.scheme===o.Schemas.file)return i.URI.file(r.dirname(p(e)));let t=r.posix.dirname(e.path);return e.authority&&t.length&&47!==t.charCodeAt(0)&&(console.error(`dirname("${e.toString})) resulted in a relative path`),t="/"),e.with({path:t})},t.joinPath=function(e,...t){let n;return n=e.scheme===o.Schemas.file?i.URI.file(r.join(p(e),...t)).path:r.posix.join(e.path||"/",...t),e.with({path:n})},t.normalizePath=function(e){if(!e.path.length)return e;let t;return t=e.scheme===o.Schemas.file?i.URI.file(r.normalize(p(e))).path:r.posix.normalize(e.path),e.with({path:t})},t.originalFSPath=p,t.isAbsolutePath=function(e){return!!e.path&&"/"===e.path[0]},t.hasTrailingPathSeparator=m,t.removeTrailingPathSeparator=function(e,t=r.sep){return m(e,t)?e.with({path:e.path.substr(0,e.path.length-1)}):e},t.addTrailingPathSeparator=function(e,t=r.sep){let i=!1;if(e.scheme===o.Schemas.file){const r=p(e);i=void 0!==r&&r.length===n.getRoot(r).length&&r[r.length-1]===t}else{t="/"
;const n=e.path;i=1===n.length&&47===n.charCodeAt(n.length-1)}return i||m(e,t)?e:e.with({path:e.path+"/"})},t.relativePath=g,t.resolvePath=function(e,t){if(e.scheme===o.Schemas.file){const n=i.URI.file(r.resolve(p(e),t));return e.with({authority:n.authority,path:n.path})}return e.with({path:r.posix.resolve(e.path,t)})},t.distinctParents=function(e,t){const n=[];for(let r=0;r<e.length;r++){const i=t(e[r]);e.some((e,n)=>n!==r&&h(i,t(e)))||n.push(e[r])}return n};!function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime",e.parseMetaData=function(t){const n=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(e=>{const[t,r]=e.split(":");t&&r&&n.set(t,r)});const r=t.path.substring(0,t.path.indexOf(";"));return r&&n.set(e.META_DATA_MIME,r),n}}(t.DataUri||(t.DataUri={}));class _{constructor(e,t){this.expressionsByRoot=l.TernarySearchTree.forPaths(),this.globalExpression=u.parse(e)
;for(const e of t)this.expressionsByRoot.set(e.root.toString(),{root:e.root,expression:u.parse(e.expression)})}matches(e){const t=this.expressionsByRoot.findSubstr(e.toString());if(t){const n=g(t.root,e);if(n&&t.expression(n))return!0}return!!this.globalExpression(e.path)}}t.ResourceGlobMatcher=_,t.toLocalResource=function(e,t){if(t){let n=e.path;return n&&n[0]!==r.posix.sep&&(n=r.posix.sep+n),e.with({scheme:o.Schemas.vscodeRemote,authority:t,path:n})}return e.with({scheme:o.Schemas.file})}}),i(e[21],t([1,0,4,3,13,15,8,20]),function(e,t,n,r,i,s,o,a){"use strict";function u(e,t=!1){const r=function(e){return{id:e.id,mime:e.mime,filename:e.filename,extension:e.extension,filepattern:e.filepattern,firstline:e.firstline,userConfigured:e.userConfigured,filenameLowercase:e.filename?e.filename.toLowerCase():void 0,extensionLowercase:e.extension?e.extension.toLowerCase():void 0,filepatternLowercase:e.filepattern?e.filepattern.toLowerCase():void 0,filepatternOnPath:!!e.filepattern&&e.filepattern.indexOf(n.posix.sep)>=0
}}(e);d.push(r),r.userConfigured?p.push(r):f.push(r),t&&!r.userConfigured&&d.forEach(e=>{e.mime===r.mime||e.userConfigured||(r.extension&&e.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&e.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&e.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&e.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}function l(e,i){let s;if(e)switch(e.scheme){case o.Schemas.file:s=e.fsPath;break;case o.Schemas.data:s=a.DataUri.parseMetaData(e).get(a.DataUri.META_DATA_LABEL);break;default:s=e.path}if(!s)return[t.MIME_UNKNOWN];s=s.toLowerCase();const u=n.basename(s),l=c(s,u,p);if(l)return[l,t.MIME_TEXT];const h=c(s,u,f);if(h)return[h,t.MIME_TEXT];if(i){const e=function(e){
r.startsWithUTF8BOM(e)&&(e=e.substr(1));if(e.length>0)for(let t=d.length-1;t>=0;t--){const n=d[t];if(!n.firstline)continue;const r=e.match(n.firstline);if(r&&r.length>0)return n.mime}return null}(i);if(e)return[e,t.MIME_TEXT]}return[t.MIME_UNKNOWN]}function c(e,t,n){let i=null,o=null,a=null;for(let u=n.length-1;u>=0;u--){const l=n[u];if(t===l.filenameLowercase){i=l;break}if(l.filepattern&&(!o||l.filepattern.length>o.filepattern.length)){const n=l.filepatternOnPath?e:t;s.match(l.filepatternLowercase,n)&&(o=l)}l.extension&&(!a||l.extension.length>a.extension.length)&&r.endsWith(t,l.extensionLowercase)&&(a=l)}return i?i.mime:o?o.mime:a?a.mime:null}function h(e){return!e||("string"==typeof e?e===t.MIME_BINARY||e===t.MIME_TEXT||e===t.MIME_UNKNOWN:1===e.length&&h(e[0]))}Object.defineProperty(t,"__esModule",{value:!0}),t.MIME_TEXT="text/plain",t.MIME_BINARY="application/octet-stream",t.MIME_UNKNOWN="application/unknown";let d=[],f=[],p=[];t.registerTextMime=u,t.clearTextMimes=function(e){
e?(d=d.filter(e=>!e.userConfigured),p=[]):(d=[],f=[],p=[])},t.guessMimeTypes=l,t.isUnspecific=h,t.suggestFilename=function(e,t){const n=d.filter(t=>!t.userConfigured&&t.extension&&t.id===e).map(e=>e.extension),s=i.coalesce(n).filter(e=>r.startsWith(e,"."));return s.length>0?t+s[0]:n[0]||t};const m={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",
".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};t.getMediaMime=function(e){const t=n.extname(e);return m[t.toLowerCase()]}}),i(e[22],t([1,0]),function(e,t){"use strict";function n(){return new s}function r(e){return o.test(e)}Object.defineProperty(t,"__esModule",{value:!0});class i{constructor(e){this._value=e}asHex(){return this._value}}class s extends i{constructor(){
super([s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),"-",s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),"-","4",s._randomHex(),s._randomHex(),s._randomHex(),"-",s._oneOf(s._timeHighBits),s._randomHex(),s._randomHex(),s._randomHex(),"-",s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex()].join(""))}static _oneOf(e){return e[Math.floor(e.length*Math.random())]}static _randomHex(){return s._oneOf(s._chars)}}s._chars=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"],s._timeHighBits=["8","9","a","b"],t.v4=n;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;t.isUUID=r,t.parse=function(e){if(!r(e))throw new Error("invalid uuid");return new i(e)},t.generateUuid=function(){return n().asHex()}}),i(e[23],t([1,0,5,22,21]),function(e,t,n,r,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),self.addEventListener("install",e=>{console.log("SW#install"),self.skipWaiting()}),self.addEventListener("activate",e=>{console.log("SW#activate"),e.waitUntil((()=>o(this,void 0,void 0,function*(){self.registration.navigationPreload&&(yield self.registration.navigationPreload.enable()),yield caches.delete(s),yield self.clients.claim()}))())});const s="vscode-resources",a=new Map;self.addEventListener("message",e=>{const t=a.get(e.data.token);t&&(t(e.data.data,e.data.isExtensionResource),a.delete(e.data.token))}),self.addEventListener("fetch",e=>o(this,void 0,void 0,function*(){const t=n.URI.parse(e.request.url);"/vscode-resources/fetch"===t.path?e.respondWith(function(e,t){return o(this,void 0,void 0,function*(){const n=e.request.url.replace("&r=1",""),u=yield caches.open(s).then(e=>e.match(n));return u||new Promise(u=>{const l=r.generateUuid(),[c]=t.query.split("&"),h=JSON.parse(c.substr(2));a.set(l,(e,t)=>o(this,void 0,void 0,function*(){
const r=new Response(e,{status:200,headers:{"Content-Type":i.getMediaMime(h.path)||"text/plain"}});return t&&(yield caches.open(s).then(e=>e.put(n,r.clone()))),u(r)})),self.clients.get(e.clientId).then(e=>{e.postMessage({uri:h,token:l})})})})}(e,t)):e.respondWith(function(e){return o(this,void 0,void 0,function*(){return"only-if-cached"===e.request.cache&&"same-origin"!==e.request.mode?new Response(void 0,{status:504,statusText:"Gateway Timeout (dev tools: https://bugs.chromium.org/p/chromium/issues/detail?id=823392)"}):(yield e.preloadResponse)||(yield fetch(e.request))})}(e))}))});importScripts("../../../../../vs/loader.js"),require.config({baseUrl:"../../../../../",catchError:!0}),require(["vs/workbench/contrib/resources/browser/resourceServiceWorker"],()=>{},e=>console.error(e))}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f06011ac164ae4dc8e753a3fe7f9549844d15e35/core/vs/workbench/contrib/resources/browser/resourceServiceWorkerMain.js.map
